/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { AppointmentTimetableOverridesModel } from '../models';
import { AppointmentTimetablesModel } from '../models';
import { BatchAppointmentTimetablesResultModel } from '../models';
import { BatchDealPackageAppointmentTimetablesCommand } from '../models';
import { CreateDealCommand } from '../models';
import { CreateDealPackageCommand } from '../models';
import { CreateDealServiceCommand } from '../models';
import { DayOfWeek } from '../models';
import { DealModel } from '../models';
import { DealPackageModel } from '../models';
import { DealPackagesModel } from '../models';
import { DealServiceModel } from '../models';
import { DealServicesModel } from '../models';
import { DealsModel } from '../models';
import { DealsSimpleModel } from '../models';
import { DeleteDealPackageAppointmentTimetableOverridesCommand } from '../models';
import { GetAppointmentTimetablesResponseModel } from '../models';
import { MarketingType } from '../models';
import { SaveAppointmentTimetableOverridesResultModel } from '../models';
import { SaveDealPackageAppointmentTimetableOverridesCommand } from '../models';
import { TranslateDealCommand } from '../models';
import { UpdateDealCommand } from '../models';
import { UpdateDealPackageCommand } from '../models';
import { UpdateDealServiceCommand } from '../models';
/**
 * DealsApi - axios parameter creator
 * @export
 */
export declare const DealsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete deal.
     * @param {string} dealId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdDelete: (dealId: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get deal.
     * @param {string} dealId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdGet: (dealId: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all DealPackage.
     * @param {string} dealId
     * @param {string} [relatedDealPackageId]
     * @param {string} [dealName]
     * @param {string} [name]
     * @param {string} [countryId]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesGet: (dealId: string, relatedDealPackageId?: string, dealName?: string, name?: string, countryId?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get DealPackage appointment timetable overrides
     * @param {string} dealId
     * @param {string} packageId
     * @param {boolean} [includesPreviousItems]
     * @param {Date} [startDate]
     * @param {Date} [endDate]
     * @param {DayOfWeek} [dayOfWeek]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet: (dealId: string, packageId: string, includesPreviousItems?: boolean, startDate?: Date, endDate?: Date, dayOfWeek?: DayOfWeek, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete DealPackage appointment timetable overrides
     * @param {string} dealId
     * @param {string} packageId
     * @param {DeleteDealPackageAppointmentTimetableOverridesCommand} [deleteDealPackageAppointmentTimetableOverridesCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch: (dealId: string, packageId: string, deleteDealPackageAppointmentTimetableOverridesCommand?: DeleteDealPackageAppointmentTimetableOverridesCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Save DealPackage appointment timetable overrides
     * @param {string} dealId
     * @param {string} packageId
     * @param {SaveDealPackageAppointmentTimetableOverridesCommand} [saveDealPackageAppointmentTimetableOverridesCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost: (dealId: string, packageId: string, saveDealPackageAppointmentTimetableOverridesCommand?: SaveDealPackageAppointmentTimetableOverridesCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get DealPackage appointment timetables for application
     * @param {string} dealId
     * @param {string} packageId
     * @param {number} [year]
     * @param {number} [month]
     * @param {string} [timeZone]
     * @param {boolean} [isExternal]
     * @param {boolean} [isOnline]
     * @param {string} [appointmentIdExcluded]
     * @param {boolean} [excludeUnavailableTimeSlots]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet: (dealId: string, packageId: string, year?: number, month?: number, timeZone?: string, isExternal?: boolean, isOnline?: boolean, appointmentIdExcluded?: string, excludeUnavailableTimeSlots?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Add, update and delete DealPackage appointment timetable
     * @param {string} dealId
     * @param {string} packageId
     * @param {BatchDealPackageAppointmentTimetablesCommand} [batchDealPackageAppointmentTimetablesCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost: (dealId: string, packageId: string, batchDealPackageAppointmentTimetablesCommand?: BatchDealPackageAppointmentTimetablesCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get DealPackage appointment timetables
     * @param {string} dealId
     * @param {string} packageId
     * @param {DayOfWeek} [dayOfWeek]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet: (dealId: string, packageId: string, dayOfWeek?: DayOfWeek, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete DealPackage.
     * @param {string} dealId
     * @param {string} packageId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdDelete: (dealId: string, packageId: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get DealPackage.
     * @param {string} dealId
     * @param {string} packageId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdGet: (dealId: string, packageId: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update DealPackage.
     * @param {string} dealId
     * @param {string} packageId
     * @param {UpdateDealPackageCommand} [updateDealPackageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdPut: (dealId: string, packageId: string, updateDealPackageCommand?: UpdateDealPackageCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create DealPackage.
     * @param {string} dealId
     * @param {CreateDealPackageCommand} [createDealPackageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPost: (dealId: string, createDealPackageCommand?: CreateDealPackageCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update deal.
     * @param {string} dealId
     * @param {UpdateDealCommand} [updateDealCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPut: (dealId: string, updateDealCommand?: UpdateDealCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Revalidate deal
     * @param {string} dealId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdRevalidatePost: (dealId: string, includeCurrent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all DealService.
     * @param {string} dealId
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesGet: (dealId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create DealService.
     * @param {string} dealId
     * @param {CreateDealServiceCommand} [createDealServiceCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesPost: (dealId: string, createDealServiceCommand?: CreateDealServiceCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete DealService.
     * @param {string} dealId
     * @param {string} serviceId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesServiceIdDelete: (dealId: string, serviceId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get DealService.
     * @param {string} dealId
     * @param {string} serviceId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesServiceIdGet: (dealId: string, serviceId: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update DealService.
     * @param {string} dealId
     * @param {string} serviceId
     * @param {UpdateDealServiceCommand} [updateDealServiceCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesServiceIdPut: (dealId: string, serviceId: string, updateDealServiceCommand?: UpdateDealServiceCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Translate deal
     * @param {string} dealId
     * @param {TranslateDealCommand} [translateDealCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdTranslatePost: (dealId: string, translateDealCommand?: TranslateDealCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all deals.
     * @param {string} [id]
     * @param {string} [name]
     * @param {MarketingType} [marketingType]
     * @param {string} [countryId]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [specialtyId]
     * @param {string} [specialtyName]
     * @param {string} [specialtyTypeId]
     * @param {string} [specialtyTypeName]
     * @param {string} [serviceId]
     * @param {string} [serviceName]
     * @param {string} [exceptHospitalId]
     * @param {string} [exceptDealId]
     * @param {Array<string>} [ids]
     * @param {number} [serviceDuration]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsGet: (id?: string, name?: string, marketingType?: MarketingType, countryId?: string, hospitalId?: string, hospitalName?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceId?: string, serviceName?: string, exceptHospitalId?: string, exceptDealId?: string, ids?: Array<string>, serviceDuration?: number, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a deal.
     * @param {CreateDealCommand} [createDealCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsPost: (createDealCommand?: CreateDealCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all deals.
     * @param {string} [id]
     * @param {string} [name]
     * @param {MarketingType} [marketingType]
     * @param {string} [countryId]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [specialtyId]
     * @param {string} [specialtyName]
     * @param {string} [specialtyTypeId]
     * @param {string} [specialtyTypeName]
     * @param {string} [serviceId]
     * @param {string} [serviceName]
     * @param {string} [exceptHospitalId]
     * @param {string} [exceptDealId]
     * @param {Array<string>} [ids]
     * @param {number} [serviceDuration]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsSimpleGet: (id?: string, name?: string, marketingType?: MarketingType, countryId?: string, hospitalId?: string, hospitalName?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceId?: string, serviceName?: string, exceptHospitalId?: string, exceptDealId?: string, ids?: Array<string>, serviceDuration?: number, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get deal by slug.
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsSlugGet: (slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * DealsApi - functional programming interface
 * @export
 */
export declare const DealsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete deal.
     * @param {string} dealId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdDelete(dealId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get deal.
     * @param {string} dealId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdGet(dealId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealModel>>;
    /**
     *
     * @summary Get all DealPackage.
     * @param {string} dealId
     * @param {string} [relatedDealPackageId]
     * @param {string} [dealName]
     * @param {string} [name]
     * @param {string} [countryId]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesGet(dealId: string, relatedDealPackageId?: string, dealName?: string, name?: string, countryId?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealPackagesModel>>;
    /**
     *
     * @summary Get DealPackage appointment timetable overrides
     * @param {string} dealId
     * @param {string} packageId
     * @param {boolean} [includesPreviousItems]
     * @param {Date} [startDate]
     * @param {Date} [endDate]
     * @param {DayOfWeek} [dayOfWeek]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet(dealId: string, packageId: string, includesPreviousItems?: boolean, startDate?: Date, endDate?: Date, dayOfWeek?: DayOfWeek, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AppointmentTimetableOverridesModel>>;
    /**
     *
     * @summary Delete DealPackage appointment timetable overrides
     * @param {string} dealId
     * @param {string} packageId
     * @param {DeleteDealPackageAppointmentTimetableOverridesCommand} [deleteDealPackageAppointmentTimetableOverridesCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch(dealId: string, packageId: string, deleteDealPackageAppointmentTimetableOverridesCommand?: DeleteDealPackageAppointmentTimetableOverridesCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Save DealPackage appointment timetable overrides
     * @param {string} dealId
     * @param {string} packageId
     * @param {SaveDealPackageAppointmentTimetableOverridesCommand} [saveDealPackageAppointmentTimetableOverridesCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost(dealId: string, packageId: string, saveDealPackageAppointmentTimetableOverridesCommand?: SaveDealPackageAppointmentTimetableOverridesCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SaveAppointmentTimetableOverridesResultModel>>;
    /**
     *
     * @summary Get DealPackage appointment timetables for application
     * @param {string} dealId
     * @param {string} packageId
     * @param {number} [year]
     * @param {number} [month]
     * @param {string} [timeZone]
     * @param {boolean} [isExternal]
     * @param {boolean} [isOnline]
     * @param {string} [appointmentIdExcluded]
     * @param {boolean} [excludeUnavailableTimeSlots]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet(dealId: string, packageId: string, year?: number, month?: number, timeZone?: string, isExternal?: boolean, isOnline?: boolean, appointmentIdExcluded?: string, excludeUnavailableTimeSlots?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GetAppointmentTimetablesResponseModel>>;
    /**
     *
     * @summary Add, update and delete DealPackage appointment timetable
     * @param {string} dealId
     * @param {string} packageId
     * @param {BatchDealPackageAppointmentTimetablesCommand} [batchDealPackageAppointmentTimetablesCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost(dealId: string, packageId: string, batchDealPackageAppointmentTimetablesCommand?: BatchDealPackageAppointmentTimetablesCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<BatchAppointmentTimetablesResultModel>>;
    /**
     *
     * @summary Get DealPackage appointment timetables
     * @param {string} dealId
     * @param {string} packageId
     * @param {DayOfWeek} [dayOfWeek]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet(dealId: string, packageId: string, dayOfWeek?: DayOfWeek, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AppointmentTimetablesModel>>;
    /**
     *
     * @summary Delete DealPackage.
     * @param {string} dealId
     * @param {string} packageId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdDelete(dealId: string, packageId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get DealPackage.
     * @param {string} dealId
     * @param {string} packageId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdGet(dealId: string, packageId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealPackageModel>>;
    /**
     *
     * @summary Update DealPackage.
     * @param {string} dealId
     * @param {string} packageId
     * @param {UpdateDealPackageCommand} [updateDealPackageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdPut(dealId: string, packageId: string, updateDealPackageCommand?: UpdateDealPackageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealPackageModel>>;
    /**
     *
     * @summary Create DealPackage.
     * @param {string} dealId
     * @param {CreateDealPackageCommand} [createDealPackageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPost(dealId: string, createDealPackageCommand?: CreateDealPackageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealPackageModel>>;
    /**
     *
     * @summary Update deal.
     * @param {string} dealId
     * @param {UpdateDealCommand} [updateDealCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPut(dealId: string, updateDealCommand?: UpdateDealCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealModel>>;
    /**
     *
     * @summary Revalidate deal
     * @param {string} dealId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdRevalidatePost(dealId: string, includeCurrent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get all DealService.
     * @param {string} dealId
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesGet(dealId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealServicesModel>>;
    /**
     *
     * @summary Create DealService.
     * @param {string} dealId
     * @param {CreateDealServiceCommand} [createDealServiceCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesPost(dealId: string, createDealServiceCommand?: CreateDealServiceCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealServiceModel>>;
    /**
     *
     * @summary Delete DealService.
     * @param {string} dealId
     * @param {string} serviceId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesServiceIdDelete(dealId: string, serviceId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get DealService.
     * @param {string} dealId
     * @param {string} serviceId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesServiceIdGet(dealId: string, serviceId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealServiceModel>>;
    /**
     *
     * @summary Update DealService.
     * @param {string} dealId
     * @param {string} serviceId
     * @param {UpdateDealServiceCommand} [updateDealServiceCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesServiceIdPut(dealId: string, serviceId: string, updateDealServiceCommand?: UpdateDealServiceCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealServiceModel>>;
    /**
     *
     * @summary Translate deal
     * @param {string} dealId
     * @param {TranslateDealCommand} [translateDealCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdTranslatePost(dealId: string, translateDealCommand?: TranslateDealCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get all deals.
     * @param {string} [id]
     * @param {string} [name]
     * @param {MarketingType} [marketingType]
     * @param {string} [countryId]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [specialtyId]
     * @param {string} [specialtyName]
     * @param {string} [specialtyTypeId]
     * @param {string} [specialtyTypeName]
     * @param {string} [serviceId]
     * @param {string} [serviceName]
     * @param {string} [exceptHospitalId]
     * @param {string} [exceptDealId]
     * @param {Array<string>} [ids]
     * @param {number} [serviceDuration]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsGet(id?: string, name?: string, marketingType?: MarketingType, countryId?: string, hospitalId?: string, hospitalName?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceId?: string, serviceName?: string, exceptHospitalId?: string, exceptDealId?: string, ids?: Array<string>, serviceDuration?: number, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealsModel>>;
    /**
     *
     * @summary Create a deal.
     * @param {CreateDealCommand} [createDealCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsPost(createDealCommand?: CreateDealCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealModel>>;
    /**
     *
     * @summary Get all deals.
     * @param {string} [id]
     * @param {string} [name]
     * @param {MarketingType} [marketingType]
     * @param {string} [countryId]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [specialtyId]
     * @param {string} [specialtyName]
     * @param {string} [specialtyTypeId]
     * @param {string} [specialtyTypeName]
     * @param {string} [serviceId]
     * @param {string} [serviceName]
     * @param {string} [exceptHospitalId]
     * @param {string} [exceptDealId]
     * @param {Array<string>} [ids]
     * @param {number} [serviceDuration]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsSimpleGet(id?: string, name?: string, marketingType?: MarketingType, countryId?: string, hospitalId?: string, hospitalName?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceId?: string, serviceName?: string, exceptHospitalId?: string, exceptDealId?: string, ids?: Array<string>, serviceDuration?: number, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealsSimpleModel>>;
    /**
     *
     * @summary Get deal by slug.
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DealModel>>;
};
/**
 * DealsApi - factory interface
 * @export
 */
export declare const DealsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Delete deal.
     * @param {string} dealId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdDelete(dealId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get deal.
     * @param {string} dealId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdGet(dealId: string, languageCode?: string, options?: any): AxiosPromise<DealModel>;
    /**
     *
     * @summary Get all DealPackage.
     * @param {string} dealId
     * @param {string} [relatedDealPackageId]
     * @param {string} [dealName]
     * @param {string} [name]
     * @param {string} [countryId]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesGet(dealId: string, relatedDealPackageId?: string, dealName?: string, name?: string, countryId?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DealPackagesModel>;
    /**
     *
     * @summary Get DealPackage appointment timetable overrides
     * @param {string} dealId
     * @param {string} packageId
     * @param {boolean} [includesPreviousItems]
     * @param {Date} [startDate]
     * @param {Date} [endDate]
     * @param {DayOfWeek} [dayOfWeek]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet(dealId: string, packageId: string, includesPreviousItems?: boolean, startDate?: Date, endDate?: Date, dayOfWeek?: DayOfWeek, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<AppointmentTimetableOverridesModel>;
    /**
     *
     * @summary Delete DealPackage appointment timetable overrides
     * @param {string} dealId
     * @param {string} packageId
     * @param {DeleteDealPackageAppointmentTimetableOverridesCommand} [deleteDealPackageAppointmentTimetableOverridesCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch(dealId: string, packageId: string, deleteDealPackageAppointmentTimetableOverridesCommand?: DeleteDealPackageAppointmentTimetableOverridesCommand, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Save DealPackage appointment timetable overrides
     * @param {string} dealId
     * @param {string} packageId
     * @param {SaveDealPackageAppointmentTimetableOverridesCommand} [saveDealPackageAppointmentTimetableOverridesCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost(dealId: string, packageId: string, saveDealPackageAppointmentTimetableOverridesCommand?: SaveDealPackageAppointmentTimetableOverridesCommand, options?: any): AxiosPromise<SaveAppointmentTimetableOverridesResultModel>;
    /**
     *
     * @summary Get DealPackage appointment timetables for application
     * @param {string} dealId
     * @param {string} packageId
     * @param {number} [year]
     * @param {number} [month]
     * @param {string} [timeZone]
     * @param {boolean} [isExternal]
     * @param {boolean} [isOnline]
     * @param {string} [appointmentIdExcluded]
     * @param {boolean} [excludeUnavailableTimeSlots]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet(dealId: string, packageId: string, year?: number, month?: number, timeZone?: string, isExternal?: boolean, isOnline?: boolean, appointmentIdExcluded?: string, excludeUnavailableTimeSlots?: boolean, options?: any): AxiosPromise<GetAppointmentTimetablesResponseModel>;
    /**
     *
     * @summary Add, update and delete DealPackage appointment timetable
     * @param {string} dealId
     * @param {string} packageId
     * @param {BatchDealPackageAppointmentTimetablesCommand} [batchDealPackageAppointmentTimetablesCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost(dealId: string, packageId: string, batchDealPackageAppointmentTimetablesCommand?: BatchDealPackageAppointmentTimetablesCommand, options?: any): AxiosPromise<BatchAppointmentTimetablesResultModel>;
    /**
     *
     * @summary Get DealPackage appointment timetables
     * @param {string} dealId
     * @param {string} packageId
     * @param {DayOfWeek} [dayOfWeek]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet(dealId: string, packageId: string, dayOfWeek?: DayOfWeek, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<AppointmentTimetablesModel>;
    /**
     *
     * @summary Delete DealPackage.
     * @param {string} dealId
     * @param {string} packageId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdDelete(dealId: string, packageId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get DealPackage.
     * @param {string} dealId
     * @param {string} packageId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdGet(dealId: string, packageId: string, languageCode?: string, options?: any): AxiosPromise<DealPackageModel>;
    /**
     *
     * @summary Update DealPackage.
     * @param {string} dealId
     * @param {string} packageId
     * @param {UpdateDealPackageCommand} [updateDealPackageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPackageIdPut(dealId: string, packageId: string, updateDealPackageCommand?: UpdateDealPackageCommand, options?: any): AxiosPromise<DealPackageModel>;
    /**
     *
     * @summary Create DealPackage.
     * @param {string} dealId
     * @param {CreateDealPackageCommand} [createDealPackageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPackagesPost(dealId: string, createDealPackageCommand?: CreateDealPackageCommand, options?: any): AxiosPromise<DealPackageModel>;
    /**
     *
     * @summary Update deal.
     * @param {string} dealId
     * @param {UpdateDealCommand} [updateDealCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdPut(dealId: string, updateDealCommand?: UpdateDealCommand, options?: any): AxiosPromise<DealModel>;
    /**
     *
     * @summary Revalidate deal
     * @param {string} dealId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdRevalidatePost(dealId: string, includeCurrent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get all DealService.
     * @param {string} dealId
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesGet(dealId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DealServicesModel>;
    /**
     *
     * @summary Create DealService.
     * @param {string} dealId
     * @param {CreateDealServiceCommand} [createDealServiceCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesPost(dealId: string, createDealServiceCommand?: CreateDealServiceCommand, options?: any): AxiosPromise<DealServiceModel>;
    /**
     *
     * @summary Delete DealService.
     * @param {string} dealId
     * @param {string} serviceId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesServiceIdDelete(dealId: string, serviceId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get DealService.
     * @param {string} dealId
     * @param {string} serviceId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesServiceIdGet(dealId: string, serviceId: string, languageCode?: string, options?: any): AxiosPromise<DealServiceModel>;
    /**
     *
     * @summary Update DealService.
     * @param {string} dealId
     * @param {string} serviceId
     * @param {UpdateDealServiceCommand} [updateDealServiceCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdServicesServiceIdPut(dealId: string, serviceId: string, updateDealServiceCommand?: UpdateDealServiceCommand, options?: any): AxiosPromise<DealServiceModel>;
    /**
     *
     * @summary Translate deal
     * @param {string} dealId
     * @param {TranslateDealCommand} [translateDealCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsDealIdTranslatePost(dealId: string, translateDealCommand?: TranslateDealCommand, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get all deals.
     * @param {string} [id]
     * @param {string} [name]
     * @param {MarketingType} [marketingType]
     * @param {string} [countryId]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [specialtyId]
     * @param {string} [specialtyName]
     * @param {string} [specialtyTypeId]
     * @param {string} [specialtyTypeName]
     * @param {string} [serviceId]
     * @param {string} [serviceName]
     * @param {string} [exceptHospitalId]
     * @param {string} [exceptDealId]
     * @param {Array<string>} [ids]
     * @param {number} [serviceDuration]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsGet(id?: string, name?: string, marketingType?: MarketingType, countryId?: string, hospitalId?: string, hospitalName?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceId?: string, serviceName?: string, exceptHospitalId?: string, exceptDealId?: string, ids?: Array<string>, serviceDuration?: number, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DealsModel>;
    /**
     *
     * @summary Create a deal.
     * @param {CreateDealCommand} [createDealCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsPost(createDealCommand?: CreateDealCommand, options?: any): AxiosPromise<DealModel>;
    /**
     *
     * @summary Get all deals.
     * @param {string} [id]
     * @param {string} [name]
     * @param {MarketingType} [marketingType]
     * @param {string} [countryId]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [specialtyId]
     * @param {string} [specialtyName]
     * @param {string} [specialtyTypeId]
     * @param {string} [specialtyTypeName]
     * @param {string} [serviceId]
     * @param {string} [serviceName]
     * @param {string} [exceptHospitalId]
     * @param {string} [exceptDealId]
     * @param {Array<string>} [ids]
     * @param {number} [serviceDuration]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsSimpleGet(id?: string, name?: string, marketingType?: MarketingType, countryId?: string, hospitalId?: string, hospitalName?: string, specialtyId?: string, specialtyName?: string, specialtyTypeId?: string, specialtyTypeName?: string, serviceId?: string, serviceName?: string, exceptHospitalId?: string, exceptDealId?: string, ids?: Array<string>, serviceDuration?: number, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<DealsSimpleModel>;
    /**
     *
     * @summary Get deal by slug.
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1DealsSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<DealModel>;
};
/**
 * Request parameters for apiV1DealsDealIdDelete operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdDeleteRequest
 */
export interface DealsApiApiV1DealsDealIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdDelete
     */
    readonly dealId: string;
    /**
     *
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1DealsDealIdGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdGetRequest
 */
export interface DealsApiApiV1DealsDealIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdGet
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdGet
     */
    readonly languageCode?: string;
}
/**
 * Request parameters for apiV1DealsDealIdPackagesGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesGetRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesGetRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly relatedDealPackageId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly dealName?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly name?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly countryId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly hospitalName?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof DealsApiApiV1DealsDealIdPackagesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGetRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGetRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly packageId: string;
    /**
     *
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly includesPreviousItems?: boolean;
    /**
     *
     * @type {Date}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly startDate?: Date;
    /**
     *
     * @type {Date}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly endDate?: Date;
    /**
     *
     * @type {DayOfWeek}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly dayOfWeek?: DayOfWeek;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatchRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatchRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch
     */
    readonly packageId: string;
    /**
     *
     * @type {DeleteDealPackageAppointmentTimetableOverridesCommand}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch
     */
    readonly deleteDealPackageAppointmentTimetableOverridesCommand?: DeleteDealPackageAppointmentTimetableOverridesCommand;
}
/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPostRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPostRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost
     */
    readonly packageId: string;
    /**
     *
     * @type {SaveDealPackageAppointmentTimetableOverridesCommand}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost
     */
    readonly saveDealPackageAppointmentTimetableOverridesCommand?: SaveDealPackageAppointmentTimetableOverridesCommand;
}
/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGetRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGetRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly packageId: string;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly year?: number;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly month?: number;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly timeZone?: string;
    /**
     *
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly isExternal?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly isOnline?: boolean;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly appointmentIdExcluded?: string;
    /**
     *
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet
     */
    readonly excludeUnavailableTimeSlots?: boolean;
}
/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPostRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPostRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost
     */
    readonly packageId: string;
    /**
     *
     * @type {BatchDealPackageAppointmentTimetablesCommand}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost
     */
    readonly batchDealPackageAppointmentTimetablesCommand?: BatchDealPackageAppointmentTimetablesCommand;
}
/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGetRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGetRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet
     */
    readonly packageId: string;
    /**
     *
     * @type {DayOfWeek}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet
     */
    readonly dayOfWeek?: DayOfWeek;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdDelete operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdDeleteRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdDelete
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdDelete
     */
    readonly packageId: string;
    /**
     *
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdGetRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdGet
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdGet
     */
    readonly packageId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdGet
     */
    readonly languageCode?: string;
}
/**
 * Request parameters for apiV1DealsDealIdPackagesPackageIdPut operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPackageIdPutRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPackageIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdPut
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdPut
     */
    readonly packageId: string;
    /**
     *
     * @type {UpdateDealPackageCommand}
     * @memberof DealsApiApiV1DealsDealIdPackagesPackageIdPut
     */
    readonly updateDealPackageCommand?: UpdateDealPackageCommand;
}
/**
 * Request parameters for apiV1DealsDealIdPackagesPost operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPackagesPostRequest
 */
export interface DealsApiApiV1DealsDealIdPackagesPostRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPackagesPost
     */
    readonly dealId: string;
    /**
     *
     * @type {CreateDealPackageCommand}
     * @memberof DealsApiApiV1DealsDealIdPackagesPost
     */
    readonly createDealPackageCommand?: CreateDealPackageCommand;
}
/**
 * Request parameters for apiV1DealsDealIdPut operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdPutRequest
 */
export interface DealsApiApiV1DealsDealIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdPut
     */
    readonly dealId: string;
    /**
     *
     * @type {UpdateDealCommand}
     * @memberof DealsApiApiV1DealsDealIdPut
     */
    readonly updateDealCommand?: UpdateDealCommand;
}
/**
 * Request parameters for apiV1DealsDealIdRevalidatePost operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdRevalidatePostRequest
 */
export interface DealsApiApiV1DealsDealIdRevalidatePostRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdRevalidatePost
     */
    readonly dealId: string;
    /**
     *
     * @type {boolean}
     * @memberof DealsApiApiV1DealsDealIdRevalidatePost
     */
    readonly includeCurrent?: boolean;
}
/**
 * Request parameters for apiV1DealsDealIdServicesGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdServicesGetRequest
 */
export interface DealsApiApiV1DealsDealIdServicesGetRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesGet
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdServicesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsDealIdServicesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof DealsApiApiV1DealsDealIdServicesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1DealsDealIdServicesPost operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdServicesPostRequest
 */
export interface DealsApiApiV1DealsDealIdServicesPostRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesPost
     */
    readonly dealId: string;
    /**
     *
     * @type {CreateDealServiceCommand}
     * @memberof DealsApiApiV1DealsDealIdServicesPost
     */
    readonly createDealServiceCommand?: CreateDealServiceCommand;
}
/**
 * Request parameters for apiV1DealsDealIdServicesServiceIdDelete operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdServicesServiceIdDeleteRequest
 */
export interface DealsApiApiV1DealsDealIdServicesServiceIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdDelete
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdDelete
     */
    readonly serviceId: string;
}
/**
 * Request parameters for apiV1DealsDealIdServicesServiceIdGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdServicesServiceIdGetRequest
 */
export interface DealsApiApiV1DealsDealIdServicesServiceIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdGet
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdGet
     */
    readonly serviceId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdGet
     */
    readonly languageCode?: string;
}
/**
 * Request parameters for apiV1DealsDealIdServicesServiceIdPut operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdServicesServiceIdPutRequest
 */
export interface DealsApiApiV1DealsDealIdServicesServiceIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdPut
     */
    readonly dealId: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdPut
     */
    readonly serviceId: string;
    /**
     *
     * @type {UpdateDealServiceCommand}
     * @memberof DealsApiApiV1DealsDealIdServicesServiceIdPut
     */
    readonly updateDealServiceCommand?: UpdateDealServiceCommand;
}
/**
 * Request parameters for apiV1DealsDealIdTranslatePost operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsDealIdTranslatePostRequest
 */
export interface DealsApiApiV1DealsDealIdTranslatePostRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsDealIdTranslatePost
     */
    readonly dealId: string;
    /**
     *
     * @type {TranslateDealCommand}
     * @memberof DealsApiApiV1DealsDealIdTranslatePost
     */
    readonly translateDealCommand?: TranslateDealCommand;
}
/**
 * Request parameters for apiV1DealsGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsGetRequest
 */
export interface DealsApiApiV1DealsGetRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly name?: string;
    /**
     *
     * @type {MarketingType}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly marketingType?: MarketingType;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly countryId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly hospitalName?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly specialtyId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly specialtyName?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly specialtyTypeId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly specialtyTypeName?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly serviceId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly serviceName?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly exceptHospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly exceptDealId?: string;
    /**
     *
     * @type {Array<string>}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly ids?: Array<string>;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly serviceDuration?: number;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly returnDefaultValue?: boolean;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof DealsApiApiV1DealsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1DealsPost operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsPostRequest
 */
export interface DealsApiApiV1DealsPostRequest {
    /**
     *
     * @type {CreateDealCommand}
     * @memberof DealsApiApiV1DealsPost
     */
    readonly createDealCommand?: CreateDealCommand;
}
/**
 * Request parameters for apiV1DealsSimpleGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsSimpleGetRequest
 */
export interface DealsApiApiV1DealsSimpleGetRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly name?: string;
    /**
     *
     * @type {MarketingType}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly marketingType?: MarketingType;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly countryId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly hospitalName?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly specialtyId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly specialtyName?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly specialtyTypeId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly specialtyTypeName?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly serviceId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly serviceName?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly exceptHospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly exceptDealId?: string;
    /**
     *
     * @type {Array<string>}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly ids?: Array<string>;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly serviceDuration?: number;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly returnDefaultValue?: boolean;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof DealsApiApiV1DealsSimpleGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1DealsSlugGet operation in DealsApi.
 * @export
 * @interface DealsApiApiV1DealsSlugGetRequest
 */
export interface DealsApiApiV1DealsSlugGetRequest {
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSlugGet
     */
    readonly slug: string;
    /**
     *
     * @type {string}
     * @memberof DealsApiApiV1DealsSlugGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof DealsApiApiV1DealsSlugGet
     */
    readonly returnDefaultValue?: boolean;
}
/**
 * DealsApi - object-oriented interface
 * @export
 * @class DealsApi
 * @extends {BaseAPI}
 */
export declare class DealsApi extends BaseAPI {
    /**
     *
     * @summary Delete deal.
     * @param {DealsApiApiV1DealsDealIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdDelete(requestParameters: DealsApiApiV1DealsDealIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get deal.
     * @param {DealsApiApiV1DealsDealIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdGet(requestParameters: DealsApiApiV1DealsDealIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DealModel, any>>;
    /**
     *
     * @summary Get all DealPackage.
     * @param {DealsApiApiV1DealsDealIdPackagesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdPackagesGet(requestParameters: DealsApiApiV1DealsDealIdPackagesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DealPackagesModel, any>>;
    /**
     *
     * @summary Get DealPackage appointment timetable overrides
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGet(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<AppointmentTimetableOverridesModel, any>>;
    /**
     *
     * @summary Delete DealPackage appointment timetable overrides
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatchRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatch(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPatchRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Save DealPackage appointment timetable overrides
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPost(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetableoverridesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SaveAppointmentTimetableOverridesResultModel, any>>;
    /**
     *
     * @summary Get DealPackage appointment timetables for application
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGet(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesApplicationGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<GetAppointmentTimetablesResponseModel, any>>;
    /**
     *
     * @summary Add, update and delete DealPackage appointment timetable
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPost(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesBatchPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<BatchAppointmentTimetablesResultModel, any>>;
    /**
     *
     * @summary Get DealPackage appointment timetables
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGet(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdAppointmenttimetablesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<AppointmentTimetablesModel, any>>;
    /**
     *
     * @summary Delete DealPackage.
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdPackagesPackageIdDelete(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get DealPackage.
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdPackagesPackageIdGet(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DealPackageModel, any>>;
    /**
     *
     * @summary Update DealPackage.
     * @param {DealsApiApiV1DealsDealIdPackagesPackageIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdPackagesPackageIdPut(requestParameters: DealsApiApiV1DealsDealIdPackagesPackageIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DealPackageModel, any>>;
    /**
     *
     * @summary Create DealPackage.
     * @param {DealsApiApiV1DealsDealIdPackagesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdPackagesPost(requestParameters: DealsApiApiV1DealsDealIdPackagesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DealPackageModel, any>>;
    /**
     *
     * @summary Update deal.
     * @param {DealsApiApiV1DealsDealIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdPut(requestParameters: DealsApiApiV1DealsDealIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DealModel, any>>;
    /**
     *
     * @summary Revalidate deal
     * @param {DealsApiApiV1DealsDealIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdRevalidatePost(requestParameters: DealsApiApiV1DealsDealIdRevalidatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get all DealService.
     * @param {DealsApiApiV1DealsDealIdServicesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdServicesGet(requestParameters: DealsApiApiV1DealsDealIdServicesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DealServicesModel, any>>;
    /**
     *
     * @summary Create DealService.
     * @param {DealsApiApiV1DealsDealIdServicesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdServicesPost(requestParameters: DealsApiApiV1DealsDealIdServicesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DealServiceModel, any>>;
    /**
     *
     * @summary Delete DealService.
     * @param {DealsApiApiV1DealsDealIdServicesServiceIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdServicesServiceIdDelete(requestParameters: DealsApiApiV1DealsDealIdServicesServiceIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get DealService.
     * @param {DealsApiApiV1DealsDealIdServicesServiceIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdServicesServiceIdGet(requestParameters: DealsApiApiV1DealsDealIdServicesServiceIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DealServiceModel, any>>;
    /**
     *
     * @summary Update DealService.
     * @param {DealsApiApiV1DealsDealIdServicesServiceIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdServicesServiceIdPut(requestParameters: DealsApiApiV1DealsDealIdServicesServiceIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DealServiceModel, any>>;
    /**
     *
     * @summary Translate deal
     * @param {DealsApiApiV1DealsDealIdTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsDealIdTranslatePost(requestParameters: DealsApiApiV1DealsDealIdTranslatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get all deals.
     * @param {DealsApiApiV1DealsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsGet(requestParameters?: DealsApiApiV1DealsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DealsModel, any>>;
    /**
     *
     * @summary Create a deal.
     * @param {DealsApiApiV1DealsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsPost(requestParameters?: DealsApiApiV1DealsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DealModel, any>>;
    /**
     *
     * @summary Get all deals.
     * @param {DealsApiApiV1DealsSimpleGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsSimpleGet(requestParameters?: DealsApiApiV1DealsSimpleGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DealsSimpleModel, any>>;
    /**
     *
     * @summary Get deal by slug.
     * @param {DealsApiApiV1DealsSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DealsApi
     */
    apiV1DealsSlugGet(requestParameters: DealsApiApiV1DealsSlugGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<DealModel, any>>;
}
//# sourceMappingURL=deals-api.d.ts.map