/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateLanguageCommand } from '../models';
import { LanguageModel } from '../models';
import { LanguagesModel } from '../models';
import { UpdateLanguageCommand } from '../models';
/**
 * LanguagesApi - axios parameter creator
 * @export
 */
export declare const LanguagesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary
     * @param {string} code
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesCodeDelete: (code: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get Language.
     * @param {string} code
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesCodeGet: (code: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary
     * @param {string} code
     * @param {UpdateLanguageCommand} [updateLanguageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesCodePut: (code: string, updateLanguageCommand?: UpdateLanguageCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all Languages.
     * @param {string} [code]
     * @param {string} [name]
     * @param {string} [description]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesGet: (code?: string, name?: string, description?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary
     * @param {CreateLanguageCommand} [createLanguageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesPost: (createLanguageCommand?: CreateLanguageCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * LanguagesApi - functional programming interface
 * @export
 */
export declare const LanguagesApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary
     * @param {string} code
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesCodeDelete(code: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get Language.
     * @param {string} code
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesCodeGet(code: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<LanguageModel>>;
    /**
     *
     * @summary
     * @param {string} code
     * @param {UpdateLanguageCommand} [updateLanguageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesCodePut(code: string, updateLanguageCommand?: UpdateLanguageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<LanguageModel>>;
    /**
     *
     * @summary Get all Languages.
     * @param {string} [code]
     * @param {string} [name]
     * @param {string} [description]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesGet(code?: string, name?: string, description?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<LanguagesModel>>;
    /**
     *
     * @summary
     * @param {CreateLanguageCommand} [createLanguageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesPost(createLanguageCommand?: CreateLanguageCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<LanguageModel>>;
};
/**
 * LanguagesApi - factory interface
 * @export
 */
export declare const LanguagesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary
     * @param {string} code
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesCodeDelete(code: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get Language.
     * @param {string} code
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesCodeGet(code: string, options?: any): AxiosPromise<LanguageModel>;
    /**
     *
     * @summary
     * @param {string} code
     * @param {UpdateLanguageCommand} [updateLanguageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesCodePut(code: string, updateLanguageCommand?: UpdateLanguageCommand, options?: any): AxiosPromise<LanguageModel>;
    /**
     *
     * @summary Get all Languages.
     * @param {string} [code]
     * @param {string} [name]
     * @param {string} [description]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesGet(code?: string, name?: string, description?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<LanguagesModel>;
    /**
     *
     * @summary
     * @param {CreateLanguageCommand} [createLanguageCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1LanguagesPost(createLanguageCommand?: CreateLanguageCommand, options?: any): AxiosPromise<LanguageModel>;
};
/**
 * Request parameters for apiV1LanguagesCodeDelete operation in LanguagesApi.
 * @export
 * @interface LanguagesApiApiV1LanguagesCodeDeleteRequest
 */
export interface LanguagesApiApiV1LanguagesCodeDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof LanguagesApiApiV1LanguagesCodeDelete
     */
    readonly code: string;
}
/**
 * Request parameters for apiV1LanguagesCodeGet operation in LanguagesApi.
 * @export
 * @interface LanguagesApiApiV1LanguagesCodeGetRequest
 */
export interface LanguagesApiApiV1LanguagesCodeGetRequest {
    /**
     *
     * @type {string}
     * @memberof LanguagesApiApiV1LanguagesCodeGet
     */
    readonly code: string;
}
/**
 * Request parameters for apiV1LanguagesCodePut operation in LanguagesApi.
 * @export
 * @interface LanguagesApiApiV1LanguagesCodePutRequest
 */
export interface LanguagesApiApiV1LanguagesCodePutRequest {
    /**
     *
     * @type {string}
     * @memberof LanguagesApiApiV1LanguagesCodePut
     */
    readonly code: string;
    /**
     *
     * @type {UpdateLanguageCommand}
     * @memberof LanguagesApiApiV1LanguagesCodePut
     */
    readonly updateLanguageCommand?: UpdateLanguageCommand;
}
/**
 * Request parameters for apiV1LanguagesGet operation in LanguagesApi.
 * @export
 * @interface LanguagesApiApiV1LanguagesGetRequest
 */
export interface LanguagesApiApiV1LanguagesGetRequest {
    /**
     *
     * @type {string}
     * @memberof LanguagesApiApiV1LanguagesGet
     */
    readonly code?: string;
    /**
     *
     * @type {string}
     * @memberof LanguagesApiApiV1LanguagesGet
     */
    readonly name?: string;
    /**
     *
     * @type {string}
     * @memberof LanguagesApiApiV1LanguagesGet
     */
    readonly description?: string;
    /**
     *
     * @type {boolean}
     * @memberof LanguagesApiApiV1LanguagesGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof LanguagesApiApiV1LanguagesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof LanguagesApiApiV1LanguagesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof LanguagesApiApiV1LanguagesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1LanguagesPost operation in LanguagesApi.
 * @export
 * @interface LanguagesApiApiV1LanguagesPostRequest
 */
export interface LanguagesApiApiV1LanguagesPostRequest {
    /**
     *
     * @type {CreateLanguageCommand}
     * @memberof LanguagesApiApiV1LanguagesPost
     */
    readonly createLanguageCommand?: CreateLanguageCommand;
}
/**
 * LanguagesApi - object-oriented interface
 * @export
 * @class LanguagesApi
 * @extends {BaseAPI}
 */
export declare class LanguagesApi extends BaseAPI {
    /**
     *
     * @summary
     * @param {LanguagesApiApiV1LanguagesCodeDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LanguagesApi
     */
    apiV1LanguagesCodeDelete(requestParameters: LanguagesApiApiV1LanguagesCodeDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get Language.
     * @param {LanguagesApiApiV1LanguagesCodeGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LanguagesApi
     */
    apiV1LanguagesCodeGet(requestParameters: LanguagesApiApiV1LanguagesCodeGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<LanguageModel, any>>;
    /**
     *
     * @summary
     * @param {LanguagesApiApiV1LanguagesCodePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LanguagesApi
     */
    apiV1LanguagesCodePut(requestParameters: LanguagesApiApiV1LanguagesCodePutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<LanguageModel, any>>;
    /**
     *
     * @summary Get all Languages.
     * @param {LanguagesApiApiV1LanguagesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LanguagesApi
     */
    apiV1LanguagesGet(requestParameters?: LanguagesApiApiV1LanguagesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<LanguagesModel, any>>;
    /**
     *
     * @summary
     * @param {LanguagesApiApiV1LanguagesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LanguagesApi
     */
    apiV1LanguagesPost(requestParameters?: LanguagesApiApiV1LanguagesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<LanguageModel, any>>;
}
//# sourceMappingURL=languages-api.d.ts.map