/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateManagerAffiliationCommand } from '../models';
import { CreateManagerCommand } from '../models';
import { Gender } from '../models';
import { ManagerAffiliationModel } from '../models';
import { ManagerAffiliationsModel } from '../models';
import { ManagerModel } from '../models';
import { ManagersModel } from '../models';
import { UpdateManagerCommand } from '../models';
/**
 * ManagersApi - axios parameter creator
 * @export
 */
export declare const ManagersApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all Managers.
     * @param {string} [hospitalId]
     * @param {string} [id]
     * @param {string} [fullname]
     * @param {string} [email]
     * @param {Gender} [gender]
     * @param {Date} [dateOfBirth]
     * @param {Date} [created]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersGet: (hospitalId?: string, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all manager affiliations.
     * @param {string} managerId
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdAffiliationsGet: (managerId: string, hospitalId?: string, hospitalName?: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete manager affiliation.
     * @param {string} managerId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdAffiliationsHospitalIdDelete: (managerId: string, hospitalId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get manager affiliation.
     * @param {string} managerId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdAffiliationsHospitalIdGet: (managerId: string, hospitalId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @param {string} managerId
     * @param {CreateManagerAffiliationCommand} [createManagerAffiliationCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdAffiliationsPost: (managerId: string, createManagerAffiliationCommand?: CreateManagerAffiliationCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete Manager.
     * @param {string} managerId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdDelete: (managerId: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get Manager.
     * @param {string} managerId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdGet: (managerId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update Manager.
     * @param {string} managerId
     * @param {UpdateManagerCommand} [updateManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdPut: (managerId: string, updateManagerCommand?: UpdateManagerCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a Manager.
     * @param {CreateManagerCommand} [createManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersPost: (createManagerCommand?: CreateManagerCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * ManagersApi - functional programming interface
 * @export
 */
export declare const ManagersApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all Managers.
     * @param {string} [hospitalId]
     * @param {string} [id]
     * @param {string} [fullname]
     * @param {string} [email]
     * @param {Gender} [gender]
     * @param {Date} [dateOfBirth]
     * @param {Date} [created]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersGet(hospitalId?: string, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ManagersModel>>;
    /**
     *
     * @summary Get all manager affiliations.
     * @param {string} managerId
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdAffiliationsGet(managerId: string, hospitalId?: string, hospitalName?: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ManagerAffiliationsModel>>;
    /**
     *
     * @summary Delete manager affiliation.
     * @param {string} managerId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdAffiliationsHospitalIdDelete(managerId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get manager affiliation.
     * @param {string} managerId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdAffiliationsHospitalIdGet(managerId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ManagerAffiliationModel>>;
    /**
     *
     * @param {string} managerId
     * @param {CreateManagerAffiliationCommand} [createManagerAffiliationCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdAffiliationsPost(managerId: string, createManagerAffiliationCommand?: CreateManagerAffiliationCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ManagerModel>>;
    /**
     *
     * @summary Delete Manager.
     * @param {string} managerId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdDelete(managerId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get Manager.
     * @param {string} managerId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdGet(managerId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ManagerModel>>;
    /**
     *
     * @summary Update Manager.
     * @param {string} managerId
     * @param {UpdateManagerCommand} [updateManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdPut(managerId: string, updateManagerCommand?: UpdateManagerCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ManagerModel>>;
    /**
     *
     * @summary Create a Manager.
     * @param {CreateManagerCommand} [createManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersPost(createManagerCommand?: CreateManagerCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ManagerModel>>;
};
/**
 * ManagersApi - factory interface
 * @export
 */
export declare const ManagersApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get all Managers.
     * @param {string} [hospitalId]
     * @param {string} [id]
     * @param {string} [fullname]
     * @param {string} [email]
     * @param {Gender} [gender]
     * @param {Date} [dateOfBirth]
     * @param {Date} [created]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersGet(hospitalId?: string, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<ManagersModel>;
    /**
     *
     * @summary Get all manager affiliations.
     * @param {string} managerId
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdAffiliationsGet(managerId: string, hospitalId?: string, hospitalName?: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<ManagerAffiliationsModel>;
    /**
     *
     * @summary Delete manager affiliation.
     * @param {string} managerId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdAffiliationsHospitalIdDelete(managerId: string, hospitalId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get manager affiliation.
     * @param {string} managerId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdAffiliationsHospitalIdGet(managerId: string, hospitalId: string, options?: any): AxiosPromise<ManagerAffiliationModel>;
    /**
     *
     * @param {string} managerId
     * @param {CreateManagerAffiliationCommand} [createManagerAffiliationCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdAffiliationsPost(managerId: string, createManagerAffiliationCommand?: CreateManagerAffiliationCommand, options?: any): AxiosPromise<ManagerModel>;
    /**
     *
     * @summary Delete Manager.
     * @param {string} managerId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdDelete(managerId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get Manager.
     * @param {string} managerId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdGet(managerId: string, options?: any): AxiosPromise<ManagerModel>;
    /**
     *
     * @summary Update Manager.
     * @param {string} managerId
     * @param {UpdateManagerCommand} [updateManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersManagerIdPut(managerId: string, updateManagerCommand?: UpdateManagerCommand, options?: any): AxiosPromise<ManagerModel>;
    /**
     *
     * @summary Create a Manager.
     * @param {CreateManagerCommand} [createManagerCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1ManagersPost(createManagerCommand?: CreateManagerCommand, options?: any): AxiosPromise<ManagerModel>;
};
/**
 * Request parameters for apiV1ManagersGet operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersGetRequest
 */
export interface ManagersApiApiV1ManagersGetRequest {
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly fullname?: string;
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly email?: string;
    /**
     *
     * @type {Gender}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly gender?: Gender;
    /**
     *
     * @type {Date}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly dateOfBirth?: Date;
    /**
     *
     * @type {Date}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly created?: Date;
    /**
     *
     * @type {boolean}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1ManagersManagerIdAffiliationsGet operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersManagerIdAffiliationsGetRequest
 */
export interface ManagersApiApiV1ManagersManagerIdAffiliationsGetRequest {
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsGet
     */
    readonly managerId: string;
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsGet
     */
    readonly hospitalName?: string;
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {number}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1ManagersManagerIdAffiliationsHospitalIdDelete operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdDeleteRequest
 */
export interface ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdDelete
     */
    readonly managerId: string;
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdDelete
     */
    readonly hospitalId: string;
}
/**
 * Request parameters for apiV1ManagersManagerIdAffiliationsHospitalIdGet operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdGetRequest
 */
export interface ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdGet
     */
    readonly managerId: string;
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdGet
     */
    readonly hospitalId: string;
}
/**
 * Request parameters for apiV1ManagersManagerIdAffiliationsPost operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersManagerIdAffiliationsPostRequest
 */
export interface ManagersApiApiV1ManagersManagerIdAffiliationsPostRequest {
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsPost
     */
    readonly managerId: string;
    /**
     *
     * @type {CreateManagerAffiliationCommand}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsPost
     */
    readonly createManagerAffiliationCommand?: CreateManagerAffiliationCommand;
}
/**
 * Request parameters for apiV1ManagersManagerIdDelete operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersManagerIdDeleteRequest
 */
export interface ManagersApiApiV1ManagersManagerIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdDelete
     */
    readonly managerId: string;
    /**
     *
     * @type {boolean}
     * @memberof ManagersApiApiV1ManagersManagerIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1ManagersManagerIdGet operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersManagerIdGetRequest
 */
export interface ManagersApiApiV1ManagersManagerIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdGet
     */
    readonly managerId: string;
}
/**
 * Request parameters for apiV1ManagersManagerIdPut operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersManagerIdPutRequest
 */
export interface ManagersApiApiV1ManagersManagerIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdPut
     */
    readonly managerId: string;
    /**
     *
     * @type {UpdateManagerCommand}
     * @memberof ManagersApiApiV1ManagersManagerIdPut
     */
    readonly updateManagerCommand?: UpdateManagerCommand;
}
/**
 * Request parameters for apiV1ManagersPost operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersPostRequest
 */
export interface ManagersApiApiV1ManagersPostRequest {
    /**
     *
     * @type {CreateManagerCommand}
     * @memberof ManagersApiApiV1ManagersPost
     */
    readonly createManagerCommand?: CreateManagerCommand;
}
/**
 * ManagersApi - object-oriented interface
 * @export
 * @class ManagersApi
 * @extends {BaseAPI}
 */
export declare class ManagersApi extends BaseAPI {
    /**
     *
     * @summary Get all Managers.
     * @param {ManagersApiApiV1ManagersGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    apiV1ManagersGet(requestParameters?: ManagersApiApiV1ManagersGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ManagersModel, any>>;
    /**
     *
     * @summary Get all manager affiliations.
     * @param {ManagersApiApiV1ManagersManagerIdAffiliationsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    apiV1ManagersManagerIdAffiliationsGet(requestParameters: ManagersApiApiV1ManagersManagerIdAffiliationsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ManagerAffiliationsModel, any>>;
    /**
     *
     * @summary Delete manager affiliation.
     * @param {ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    apiV1ManagersManagerIdAffiliationsHospitalIdDelete(requestParameters: ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get manager affiliation.
     * @param {ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    apiV1ManagersManagerIdAffiliationsHospitalIdGet(requestParameters: ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ManagerAffiliationModel, any>>;
    /**
     *
     * @param {ManagersApiApiV1ManagersManagerIdAffiliationsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    apiV1ManagersManagerIdAffiliationsPost(requestParameters: ManagersApiApiV1ManagersManagerIdAffiliationsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ManagerModel, any>>;
    /**
     *
     * @summary Delete Manager.
     * @param {ManagersApiApiV1ManagersManagerIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    apiV1ManagersManagerIdDelete(requestParameters: ManagersApiApiV1ManagersManagerIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get Manager.
     * @param {ManagersApiApiV1ManagersManagerIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    apiV1ManagersManagerIdGet(requestParameters: ManagersApiApiV1ManagersManagerIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ManagerModel, any>>;
    /**
     *
     * @summary Update Manager.
     * @param {ManagersApiApiV1ManagersManagerIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    apiV1ManagersManagerIdPut(requestParameters: ManagersApiApiV1ManagersManagerIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ManagerModel, any>>;
    /**
     *
     * @summary Create a Manager.
     * @param {ManagersApiApiV1ManagersPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    apiV1ManagersPost(requestParameters?: ManagersApiApiV1ManagersPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<ManagerModel, any>>;
}
//# sourceMappingURL=managers-api.d.ts.map