/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { MessageWebhookModel } from '../models';
import { RegisterMessageWebhookCommand } from '../models';
import { ToggleMessageWebhookCommand } from '../models';
/**
 * MessageWebhooksApi - axios parameter creator
 * @export
 */
export declare const MessageWebhooksApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get list of message webhooks related to the hospital
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1MessagewebhooksHospitalIdGet: (hospitalId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create message webhook on CH-Message-Broker
     * @param {RegisterMessageWebhookCommand} [registerMessageWebhookCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1MessagewebhooksPost: (registerMessageWebhookCommand?: RegisterMessageWebhookCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete message webhook by webhookId
     * @param {string} webhookId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1MessagewebhooksWebhookIdDelete: (webhookId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update message webhook by webhookId
     * @param {string} webhookId
     * @param {ToggleMessageWebhookCommand} [toggleMessageWebhookCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1MessagewebhooksWebhookIdPut: (webhookId: string, toggleMessageWebhookCommand?: ToggleMessageWebhookCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * MessageWebhooksApi - functional programming interface
 * @export
 */
export declare const MessageWebhooksApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get list of message webhooks related to the hospital
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1MessagewebhooksHospitalIdGet(hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<MessageWebhookModel>>>;
    /**
     *
     * @summary Create message webhook on CH-Message-Broker
     * @param {RegisterMessageWebhookCommand} [registerMessageWebhookCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1MessagewebhooksPost(registerMessageWebhookCommand?: RegisterMessageWebhookCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MessageWebhookModel>>;
    /**
     *
     * @summary Delete message webhook by webhookId
     * @param {string} webhookId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1MessagewebhooksWebhookIdDelete(webhookId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>>;
    /**
     *
     * @summary Update message webhook by webhookId
     * @param {string} webhookId
     * @param {ToggleMessageWebhookCommand} [toggleMessageWebhookCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1MessagewebhooksWebhookIdPut(webhookId: string, toggleMessageWebhookCommand?: ToggleMessageWebhookCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MessageWebhookModel>>;
};
/**
 * MessageWebhooksApi - factory interface
 * @export
 */
export declare const MessageWebhooksApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get list of message webhooks related to the hospital
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1MessagewebhooksHospitalIdGet(hospitalId: string, options?: any): AxiosPromise<Array<MessageWebhookModel>>;
    /**
     *
     * @summary Create message webhook on CH-Message-Broker
     * @param {RegisterMessageWebhookCommand} [registerMessageWebhookCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1MessagewebhooksPost(registerMessageWebhookCommand?: RegisterMessageWebhookCommand, options?: any): AxiosPromise<MessageWebhookModel>;
    /**
     *
     * @summary Delete message webhook by webhookId
     * @param {string} webhookId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1MessagewebhooksWebhookIdDelete(webhookId: string, options?: any): AxiosPromise<string>;
    /**
     *
     * @summary Update message webhook by webhookId
     * @param {string} webhookId
     * @param {ToggleMessageWebhookCommand} [toggleMessageWebhookCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1MessagewebhooksWebhookIdPut(webhookId: string, toggleMessageWebhookCommand?: ToggleMessageWebhookCommand, options?: any): AxiosPromise<MessageWebhookModel>;
};
/**
 * Request parameters for apiV1MessagewebhooksHospitalIdGet operation in MessageWebhooksApi.
 * @export
 * @interface MessageWebhooksApiApiV1MessagewebhooksHospitalIdGetRequest
 */
export interface MessageWebhooksApiApiV1MessagewebhooksHospitalIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof MessageWebhooksApiApiV1MessagewebhooksHospitalIdGet
     */
    readonly hospitalId: string;
}
/**
 * Request parameters for apiV1MessagewebhooksPost operation in MessageWebhooksApi.
 * @export
 * @interface MessageWebhooksApiApiV1MessagewebhooksPostRequest
 */
export interface MessageWebhooksApiApiV1MessagewebhooksPostRequest {
    /**
     *
     * @type {RegisterMessageWebhookCommand}
     * @memberof MessageWebhooksApiApiV1MessagewebhooksPost
     */
    readonly registerMessageWebhookCommand?: RegisterMessageWebhookCommand;
}
/**
 * Request parameters for apiV1MessagewebhooksWebhookIdDelete operation in MessageWebhooksApi.
 * @export
 * @interface MessageWebhooksApiApiV1MessagewebhooksWebhookIdDeleteRequest
 */
export interface MessageWebhooksApiApiV1MessagewebhooksWebhookIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof MessageWebhooksApiApiV1MessagewebhooksWebhookIdDelete
     */
    readonly webhookId: string;
}
/**
 * Request parameters for apiV1MessagewebhooksWebhookIdPut operation in MessageWebhooksApi.
 * @export
 * @interface MessageWebhooksApiApiV1MessagewebhooksWebhookIdPutRequest
 */
export interface MessageWebhooksApiApiV1MessagewebhooksWebhookIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof MessageWebhooksApiApiV1MessagewebhooksWebhookIdPut
     */
    readonly webhookId: string;
    /**
     *
     * @type {ToggleMessageWebhookCommand}
     * @memberof MessageWebhooksApiApiV1MessagewebhooksWebhookIdPut
     */
    readonly toggleMessageWebhookCommand?: ToggleMessageWebhookCommand;
}
/**
 * MessageWebhooksApi - object-oriented interface
 * @export
 * @class MessageWebhooksApi
 * @extends {BaseAPI}
 */
export declare class MessageWebhooksApi extends BaseAPI {
    /**
     *
     * @summary Get list of message webhooks related to the hospital
     * @param {MessageWebhooksApiApiV1MessagewebhooksHospitalIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MessageWebhooksApi
     */
    apiV1MessagewebhooksHospitalIdGet(requestParameters: MessageWebhooksApiApiV1MessagewebhooksHospitalIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MessageWebhookModel[], any>>;
    /**
     *
     * @summary Create message webhook on CH-Message-Broker
     * @param {MessageWebhooksApiApiV1MessagewebhooksPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MessageWebhooksApi
     */
    apiV1MessagewebhooksPost(requestParameters?: MessageWebhooksApiApiV1MessagewebhooksPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MessageWebhookModel, any>>;
    /**
     *
     * @summary Delete message webhook by webhookId
     * @param {MessageWebhooksApiApiV1MessagewebhooksWebhookIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MessageWebhooksApi
     */
    apiV1MessagewebhooksWebhookIdDelete(requestParameters: MessageWebhooksApiApiV1MessagewebhooksWebhookIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<string, any>>;
    /**
     *
     * @summary Update message webhook by webhookId
     * @param {MessageWebhooksApiApiV1MessagewebhooksWebhookIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof MessageWebhooksApi
     */
    apiV1MessagewebhooksWebhookIdPut(requestParameters: MessageWebhooksApiApiV1MessagewebhooksWebhookIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MessageWebhookModel, any>>;
}
//# sourceMappingURL=message-webhooks-api.d.ts.map