/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { ContributorModel } from '../models';
// @ts-ignore
import { ContributorSnsHandlesModel } from '../models';
// @ts-ignore
import { ContributorsModel } from '../models';
// @ts-ignore
import { CreateContributorCommand } from '../models';
// @ts-ignore
import { CreateContributorSnsHandleCommand } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { SnsHandleModel } from '../models';
// @ts-ignore
import { SnsType } from '../models';
// @ts-ignore
import { UpdateContributorCommand } from '../models';
// @ts-ignore
import { UpdateContributorSnsHandleCommand } from '../models';
/**
 * ContributorsApi - axios parameter creator
 * @export
 */
export const ContributorsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete Contributor.
         * @param {string} contributorId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdDelete: async (contributorId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'contributorId' is not null or undefined
            assertParamExists('apiV1ContributorsContributorIdDelete', 'contributorId', contributorId)
            const localVarPath = `/api/v1/contributors/{contributorId}`
                .replace(`{${"contributorId"}}`, encodeURIComponent(String(contributorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Contributor.
         * @param {string} contributorId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdGet: async (contributorId: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'contributorId' is not null or undefined
            assertParamExists('apiV1ContributorsContributorIdGet', 'contributorId', contributorId)
            const localVarPath = `/api/v1/contributors/{contributorId}`
                .replace(`{${"contributorId"}}`, encodeURIComponent(String(contributorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all ContributorHandles.
         * @param {string} contributorId 
         * @param {string} [id] 
         * @param {SnsType} [snsType] 
         * @param {string} [handle] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdHandlesGet: async (contributorId: string, id?: string, snsType?: SnsType, handle?: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'contributorId' is not null or undefined
            assertParamExists('apiV1ContributorsContributorIdHandlesGet', 'contributorId', contributorId)
            const localVarPath = `/api/v1/contributors/{contributorId}/handles`
                .replace(`{${"contributorId"}}`, encodeURIComponent(String(contributorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (snsType !== undefined) {
                localVarQueryParameter['SnsType'] = snsType;
            }

            if (handle !== undefined) {
                localVarQueryParameter['Handle'] = handle;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete ContributorHandle.
         * @param {string} contributorId 
         * @param {string} handleId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdHandlesHandleIdDelete: async (contributorId: string, handleId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'contributorId' is not null or undefined
            assertParamExists('apiV1ContributorsContributorIdHandlesHandleIdDelete', 'contributorId', contributorId)
            // verify required parameter 'handleId' is not null or undefined
            assertParamExists('apiV1ContributorsContributorIdHandlesHandleIdDelete', 'handleId', handleId)
            const localVarPath = `/api/v1/contributors/{contributorId}/handles/{handleId}`
                .replace(`{${"contributorId"}}`, encodeURIComponent(String(contributorId)))
                .replace(`{${"handleId"}}`, encodeURIComponent(String(handleId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get ContributorHandle.
         * @param {string} contributorId 
         * @param {string} handleId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdHandlesHandleIdGet: async (contributorId: string, handleId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'contributorId' is not null or undefined
            assertParamExists('apiV1ContributorsContributorIdHandlesHandleIdGet', 'contributorId', contributorId)
            // verify required parameter 'handleId' is not null or undefined
            assertParamExists('apiV1ContributorsContributorIdHandlesHandleIdGet', 'handleId', handleId)
            const localVarPath = `/api/v1/contributors/{contributorId}/handles/{handleId}`
                .replace(`{${"contributorId"}}`, encodeURIComponent(String(contributorId)))
                .replace(`{${"handleId"}}`, encodeURIComponent(String(handleId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update ContributorHandle.
         * @param {string} contributorId 
         * @param {string} handleId 
         * @param {UpdateContributorSnsHandleCommand} [updateContributorSnsHandleCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdHandlesHandleIdPut: async (contributorId: string, handleId: string, updateContributorSnsHandleCommand?: UpdateContributorSnsHandleCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'contributorId' is not null or undefined
            assertParamExists('apiV1ContributorsContributorIdHandlesHandleIdPut', 'contributorId', contributorId)
            // verify required parameter 'handleId' is not null or undefined
            assertParamExists('apiV1ContributorsContributorIdHandlesHandleIdPut', 'handleId', handleId)
            const localVarPath = `/api/v1/contributors/{contributorId}/handles/{handleId}`
                .replace(`{${"contributorId"}}`, encodeURIComponent(String(contributorId)))
                .replace(`{${"handleId"}}`, encodeURIComponent(String(handleId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateContributorSnsHandleCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get ContributorHandle.
         * @param {string} contributorId 
         * @param {CreateContributorSnsHandleCommand} [createContributorSnsHandleCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdHandlesPost: async (contributorId: string, createContributorSnsHandleCommand?: CreateContributorSnsHandleCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'contributorId' is not null or undefined
            assertParamExists('apiV1ContributorsContributorIdHandlesPost', 'contributorId', contributorId)
            const localVarPath = `/api/v1/contributors/{contributorId}/handles`
                .replace(`{${"contributorId"}}`, encodeURIComponent(String(contributorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createContributorSnsHandleCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update Contributor.
         * @param {string} contributorId 
         * @param {UpdateContributorCommand} [updateContributorCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdPut: async (contributorId: string, updateContributorCommand?: UpdateContributorCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'contributorId' is not null or undefined
            assertParamExists('apiV1ContributorsContributorIdPut', 'contributorId', contributorId)
            const localVarPath = `/api/v1/contributors/{contributorId}`
                .replace(`{${"contributorId"}}`, encodeURIComponent(String(contributorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateContributorCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Revalidate countributor
         * @param {string} contributorId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdRevalidatePost: async (contributorId: string, includeCurrent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'contributorId' is not null or undefined
            assertParamExists('apiV1ContributorsContributorIdRevalidatePost', 'contributorId', contributorId)
            const localVarPath = `/api/v1/contributors/{contributorId}/revalidate`
                .replace(`{${"contributorId"}}`, encodeURIComponent(String(contributorId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (includeCurrent !== undefined) {
                localVarQueryParameter['includeCurrent'] = includeCurrent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all Contributors.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [email] 
         * @param {string} [website] 
         * @param {string} [hospitalId] 
         * @param {boolean} [interviewerOnly] 
         * @param {boolean} [showHidden] 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsGet: async (id?: string, name?: string, email?: string, website?: string, hospitalId?: string, interviewerOnly?: boolean, showHidden?: boolean, languageCode?: string, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/contributors`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (email !== undefined) {
                localVarQueryParameter['Email'] = email;
            }

            if (website !== undefined) {
                localVarQueryParameter['Website'] = website;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (interviewerOnly !== undefined) {
                localVarQueryParameter['InterviewerOnly'] = interviewerOnly;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['ReturnDefaultValue'] = returnDefaultValue;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a Contributor.
         * @param {CreateContributorCommand} [createContributorCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsPost: async (createContributorCommand?: CreateContributorCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/contributors`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createContributorCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Contributor by slug.
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsSlugGet: async (slug: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'slug' is not null or undefined
            assertParamExists('apiV1ContributorsSlugGet', 'slug', slug)
            const localVarPath = `/api/v1/contributors/{slug}`
                .replace(`{${"slug"}}`, encodeURIComponent(String(slug)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ContributorsApi - functional programming interface
 * @export
 */
export const ContributorsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ContributorsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete Contributor.
         * @param {string} contributorId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContributorsContributorIdDelete(contributorId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContributorsContributorIdDelete(contributorId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Contributor.
         * @param {string} contributorId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContributorsContributorIdGet(contributorId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContributorModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContributorsContributorIdGet(contributorId, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all ContributorHandles.
         * @param {string} contributorId 
         * @param {string} [id] 
         * @param {SnsType} [snsType] 
         * @param {string} [handle] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContributorsContributorIdHandlesGet(contributorId: string, id?: string, snsType?: SnsType, handle?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContributorSnsHandlesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContributorsContributorIdHandlesGet(contributorId, id, snsType, handle, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete ContributorHandle.
         * @param {string} contributorId 
         * @param {string} handleId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContributorsContributorIdHandlesHandleIdDelete(contributorId: string, handleId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContributorsContributorIdHandlesHandleIdDelete(contributorId, handleId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get ContributorHandle.
         * @param {string} contributorId 
         * @param {string} handleId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContributorsContributorIdHandlesHandleIdGet(contributorId: string, handleId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SnsHandleModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContributorsContributorIdHandlesHandleIdGet(contributorId, handleId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update ContributorHandle.
         * @param {string} contributorId 
         * @param {string} handleId 
         * @param {UpdateContributorSnsHandleCommand} [updateContributorSnsHandleCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContributorsContributorIdHandlesHandleIdPut(contributorId: string, handleId: string, updateContributorSnsHandleCommand?: UpdateContributorSnsHandleCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SnsHandleModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContributorsContributorIdHandlesHandleIdPut(contributorId, handleId, updateContributorSnsHandleCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get ContributorHandle.
         * @param {string} contributorId 
         * @param {CreateContributorSnsHandleCommand} [createContributorSnsHandleCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContributorsContributorIdHandlesPost(contributorId: string, createContributorSnsHandleCommand?: CreateContributorSnsHandleCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SnsHandleModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContributorsContributorIdHandlesPost(contributorId, createContributorSnsHandleCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update Contributor.
         * @param {string} contributorId 
         * @param {UpdateContributorCommand} [updateContributorCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContributorsContributorIdPut(contributorId: string, updateContributorCommand?: UpdateContributorCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContributorModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContributorsContributorIdPut(contributorId, updateContributorCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Revalidate countributor
         * @param {string} contributorId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContributorsContributorIdRevalidatePost(contributorId: string, includeCurrent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContributorsContributorIdRevalidatePost(contributorId, includeCurrent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all Contributors.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [email] 
         * @param {string} [website] 
         * @param {string} [hospitalId] 
         * @param {boolean} [interviewerOnly] 
         * @param {boolean} [showHidden] 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContributorsGet(id?: string, name?: string, email?: string, website?: string, hospitalId?: string, interviewerOnly?: boolean, showHidden?: boolean, languageCode?: string, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContributorsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContributorsGet(id, name, email, website, hospitalId, interviewerOnly, showHidden, languageCode, returnDefaultValue, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a Contributor.
         * @param {CreateContributorCommand} [createContributorCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContributorsPost(createContributorCommand?: CreateContributorCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContributorModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContributorsPost(createContributorCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Contributor by slug.
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ContributorsSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ContributorModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ContributorsSlugGet(slug, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * ContributorsApi - factory interface
 * @export
 */
export const ContributorsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ContributorsApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete Contributor.
         * @param {string} contributorId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdDelete(contributorId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ContributorsContributorIdDelete(contributorId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Contributor.
         * @param {string} contributorId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdGet(contributorId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<ContributorModel> {
            return localVarFp.apiV1ContributorsContributorIdGet(contributorId, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all ContributorHandles.
         * @param {string} contributorId 
         * @param {string} [id] 
         * @param {SnsType} [snsType] 
         * @param {string} [handle] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdHandlesGet(contributorId: string, id?: string, snsType?: SnsType, handle?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<ContributorSnsHandlesModel> {
            return localVarFp.apiV1ContributorsContributorIdHandlesGet(contributorId, id, snsType, handle, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete ContributorHandle.
         * @param {string} contributorId 
         * @param {string} handleId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdHandlesHandleIdDelete(contributorId: string, handleId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ContributorsContributorIdHandlesHandleIdDelete(contributorId, handleId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get ContributorHandle.
         * @param {string} contributorId 
         * @param {string} handleId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdHandlesHandleIdGet(contributorId: string, handleId: string, options?: any): AxiosPromise<SnsHandleModel> {
            return localVarFp.apiV1ContributorsContributorIdHandlesHandleIdGet(contributorId, handleId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update ContributorHandle.
         * @param {string} contributorId 
         * @param {string} handleId 
         * @param {UpdateContributorSnsHandleCommand} [updateContributorSnsHandleCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdHandlesHandleIdPut(contributorId: string, handleId: string, updateContributorSnsHandleCommand?: UpdateContributorSnsHandleCommand, options?: any): AxiosPromise<SnsHandleModel> {
            return localVarFp.apiV1ContributorsContributorIdHandlesHandleIdPut(contributorId, handleId, updateContributorSnsHandleCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get ContributorHandle.
         * @param {string} contributorId 
         * @param {CreateContributorSnsHandleCommand} [createContributorSnsHandleCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdHandlesPost(contributorId: string, createContributorSnsHandleCommand?: CreateContributorSnsHandleCommand, options?: any): AxiosPromise<SnsHandleModel> {
            return localVarFp.apiV1ContributorsContributorIdHandlesPost(contributorId, createContributorSnsHandleCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update Contributor.
         * @param {string} contributorId 
         * @param {UpdateContributorCommand} [updateContributorCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdPut(contributorId: string, updateContributorCommand?: UpdateContributorCommand, options?: any): AxiosPromise<ContributorModel> {
            return localVarFp.apiV1ContributorsContributorIdPut(contributorId, updateContributorCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Revalidate countributor
         * @param {string} contributorId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsContributorIdRevalidatePost(contributorId: string, includeCurrent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ContributorsContributorIdRevalidatePost(contributorId, includeCurrent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all Contributors.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [email] 
         * @param {string} [website] 
         * @param {string} [hospitalId] 
         * @param {boolean} [interviewerOnly] 
         * @param {boolean} [showHidden] 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsGet(id?: string, name?: string, email?: string, website?: string, hospitalId?: string, interviewerOnly?: boolean, showHidden?: boolean, languageCode?: string, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<ContributorsModel> {
            return localVarFp.apiV1ContributorsGet(id, name, email, website, hospitalId, interviewerOnly, showHidden, languageCode, returnDefaultValue, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a Contributor.
         * @param {CreateContributorCommand} [createContributorCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsPost(createContributorCommand?: CreateContributorCommand, options?: any): AxiosPromise<ContributorModel> {
            return localVarFp.apiV1ContributorsPost(createContributorCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Contributor by slug.
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ContributorsSlugGet(slug: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<ContributorModel> {
            return localVarFp.apiV1ContributorsSlugGet(slug, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1ContributorsContributorIdDelete operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdDeleteRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdDelete
     */
    readonly contributorId: string

    /**
     * 
     * @type {boolean}
     * @memberof ContributorsApiApiV1ContributorsContributorIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1ContributorsContributorIdGet operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdGetRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdGet
     */
    readonly contributorId: string

    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof ContributorsApiApiV1ContributorsContributorIdGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * Request parameters for apiV1ContributorsContributorIdHandlesGet operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdHandlesGetRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdHandlesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesGet
     */
    readonly contributorId: string

    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesGet
     */
    readonly id?: string

    /**
     * 
     * @type {SnsType}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesGet
     */
    readonly snsType?: SnsType

    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesGet
     */
    readonly handle?: string

    /**
     * 
     * @type {number}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1ContributorsContributorIdHandlesHandleIdDelete operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdDeleteRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdDelete
     */
    readonly contributorId: string

    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdDelete
     */
    readonly handleId: string
}

/**
 * Request parameters for apiV1ContributorsContributorIdHandlesHandleIdGet operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdGetRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdGet
     */
    readonly contributorId: string

    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdGet
     */
    readonly handleId: string
}

/**
 * Request parameters for apiV1ContributorsContributorIdHandlesHandleIdPut operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdPutRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdPut
     */
    readonly contributorId: string

    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdPut
     */
    readonly handleId: string

    /**
     * 
     * @type {UpdateContributorSnsHandleCommand}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdPut
     */
    readonly updateContributorSnsHandleCommand?: UpdateContributorSnsHandleCommand
}

/**
 * Request parameters for apiV1ContributorsContributorIdHandlesPost operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdHandlesPostRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdHandlesPostRequest {
    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesPost
     */
    readonly contributorId: string

    /**
     * 
     * @type {CreateContributorSnsHandleCommand}
     * @memberof ContributorsApiApiV1ContributorsContributorIdHandlesPost
     */
    readonly createContributorSnsHandleCommand?: CreateContributorSnsHandleCommand
}

/**
 * Request parameters for apiV1ContributorsContributorIdPut operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdPutRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdPut
     */
    readonly contributorId: string

    /**
     * 
     * @type {UpdateContributorCommand}
     * @memberof ContributorsApiApiV1ContributorsContributorIdPut
     */
    readonly updateContributorCommand?: UpdateContributorCommand
}

/**
 * Request parameters for apiV1ContributorsContributorIdRevalidatePost operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsContributorIdRevalidatePostRequest
 */
export interface ContributorsApiApiV1ContributorsContributorIdRevalidatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsContributorIdRevalidatePost
     */
    readonly contributorId: string

    /**
     * 
     * @type {boolean}
     * @memberof ContributorsApiApiV1ContributorsContributorIdRevalidatePost
     */
    readonly includeCurrent?: boolean
}

/**
 * Request parameters for apiV1ContributorsGet operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsGetRequest
 */
export interface ContributorsApiApiV1ContributorsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly email?: string

    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly website?: string

    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {boolean}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly interviewerOnly?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly returnDefaultValue?: boolean

    /**
     * 
     * @type {number}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof ContributorsApiApiV1ContributorsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1ContributorsPost operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsPostRequest
 */
export interface ContributorsApiApiV1ContributorsPostRequest {
    /**
     * 
     * @type {CreateContributorCommand}
     * @memberof ContributorsApiApiV1ContributorsPost
     */
    readonly createContributorCommand?: CreateContributorCommand
}

/**
 * Request parameters for apiV1ContributorsSlugGet operation in ContributorsApi.
 * @export
 * @interface ContributorsApiApiV1ContributorsSlugGetRequest
 */
export interface ContributorsApiApiV1ContributorsSlugGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsSlugGet
     */
    readonly slug: string

    /**
     * 
     * @type {string}
     * @memberof ContributorsApiApiV1ContributorsSlugGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof ContributorsApiApiV1ContributorsSlugGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * ContributorsApi - object-oriented interface
 * @export
 * @class ContributorsApi
 * @extends {BaseAPI}
 */
export class ContributorsApi extends BaseAPI {
    /**
     * 
     * @summary Delete Contributor.
     * @param {ContributorsApiApiV1ContributorsContributorIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    public apiV1ContributorsContributorIdDelete(requestParameters: ContributorsApiApiV1ContributorsContributorIdDeleteRequest, options?: AxiosRequestConfig) {
        return ContributorsApiFp(this.configuration).apiV1ContributorsContributorIdDelete(requestParameters.contributorId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Contributor.
     * @param {ContributorsApiApiV1ContributorsContributorIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    public apiV1ContributorsContributorIdGet(requestParameters: ContributorsApiApiV1ContributorsContributorIdGetRequest, options?: AxiosRequestConfig) {
        return ContributorsApiFp(this.configuration).apiV1ContributorsContributorIdGet(requestParameters.contributorId, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all ContributorHandles.
     * @param {ContributorsApiApiV1ContributorsContributorIdHandlesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    public apiV1ContributorsContributorIdHandlesGet(requestParameters: ContributorsApiApiV1ContributorsContributorIdHandlesGetRequest, options?: AxiosRequestConfig) {
        return ContributorsApiFp(this.configuration).apiV1ContributorsContributorIdHandlesGet(requestParameters.contributorId, requestParameters.id, requestParameters.snsType, requestParameters.handle, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete ContributorHandle.
     * @param {ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    public apiV1ContributorsContributorIdHandlesHandleIdDelete(requestParameters: ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdDeleteRequest, options?: AxiosRequestConfig) {
        return ContributorsApiFp(this.configuration).apiV1ContributorsContributorIdHandlesHandleIdDelete(requestParameters.contributorId, requestParameters.handleId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get ContributorHandle.
     * @param {ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    public apiV1ContributorsContributorIdHandlesHandleIdGet(requestParameters: ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdGetRequest, options?: AxiosRequestConfig) {
        return ContributorsApiFp(this.configuration).apiV1ContributorsContributorIdHandlesHandleIdGet(requestParameters.contributorId, requestParameters.handleId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update ContributorHandle.
     * @param {ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    public apiV1ContributorsContributorIdHandlesHandleIdPut(requestParameters: ContributorsApiApiV1ContributorsContributorIdHandlesHandleIdPutRequest, options?: AxiosRequestConfig) {
        return ContributorsApiFp(this.configuration).apiV1ContributorsContributorIdHandlesHandleIdPut(requestParameters.contributorId, requestParameters.handleId, requestParameters.updateContributorSnsHandleCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get ContributorHandle.
     * @param {ContributorsApiApiV1ContributorsContributorIdHandlesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    public apiV1ContributorsContributorIdHandlesPost(requestParameters: ContributorsApiApiV1ContributorsContributorIdHandlesPostRequest, options?: AxiosRequestConfig) {
        return ContributorsApiFp(this.configuration).apiV1ContributorsContributorIdHandlesPost(requestParameters.contributorId, requestParameters.createContributorSnsHandleCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update Contributor.
     * @param {ContributorsApiApiV1ContributorsContributorIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    public apiV1ContributorsContributorIdPut(requestParameters: ContributorsApiApiV1ContributorsContributorIdPutRequest, options?: AxiosRequestConfig) {
        return ContributorsApiFp(this.configuration).apiV1ContributorsContributorIdPut(requestParameters.contributorId, requestParameters.updateContributorCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Revalidate countributor
     * @param {ContributorsApiApiV1ContributorsContributorIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    public apiV1ContributorsContributorIdRevalidatePost(requestParameters: ContributorsApiApiV1ContributorsContributorIdRevalidatePostRequest, options?: AxiosRequestConfig) {
        return ContributorsApiFp(this.configuration).apiV1ContributorsContributorIdRevalidatePost(requestParameters.contributorId, requestParameters.includeCurrent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all Contributors.
     * @param {ContributorsApiApiV1ContributorsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    public apiV1ContributorsGet(requestParameters: ContributorsApiApiV1ContributorsGetRequest = {}, options?: AxiosRequestConfig) {
        return ContributorsApiFp(this.configuration).apiV1ContributorsGet(requestParameters.id, requestParameters.name, requestParameters.email, requestParameters.website, requestParameters.hospitalId, requestParameters.interviewerOnly, requestParameters.showHidden, requestParameters.languageCode, requestParameters.returnDefaultValue, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a Contributor.
     * @param {ContributorsApiApiV1ContributorsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    public apiV1ContributorsPost(requestParameters: ContributorsApiApiV1ContributorsPostRequest = {}, options?: AxiosRequestConfig) {
        return ContributorsApiFp(this.configuration).apiV1ContributorsPost(requestParameters.createContributorCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Contributor by slug.
     * @param {ContributorsApiApiV1ContributorsSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ContributorsApi
     */
    public apiV1ContributorsSlugGet(requestParameters: ContributorsApiApiV1ContributorsSlugGetRequest, options?: AxiosRequestConfig) {
        return ContributorsApiFp(this.configuration).apiV1ContributorsSlugGet(requestParameters.slug, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }
}
