/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateManagerAffiliationCommand } from '../models';
// @ts-ignore
import { CreateManagerCommand } from '../models';
// @ts-ignore
import { Gender } from '../models';
// @ts-ignore
import { ManagerAffiliationModel } from '../models';
// @ts-ignore
import { ManagerAffiliationsModel } from '../models';
// @ts-ignore
import { ManagerModel } from '../models';
// @ts-ignore
import { ManagersModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateManagerCommand } from '../models';
/**
 * ManagersApi - axios parameter creator
 * @export
 */
export const ManagersApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all Managers.
         * @param {string} [hospitalId] 
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersGet: async (hospitalId?: string, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/managers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (fullname !== undefined) {
                localVarQueryParameter['Fullname'] = fullname;
            }

            if (email !== undefined) {
                localVarQueryParameter['Email'] = email;
            }

            if (gender !== undefined) {
                localVarQueryParameter['Gender'] = gender;
            }

            if (dateOfBirth !== undefined) {
                localVarQueryParameter['DateOfBirth'] = (dateOfBirth as any instanceof Date) ?
                    (dateOfBirth as any).toISOString() :
                    dateOfBirth;
            }

            if (created !== undefined) {
                localVarQueryParameter['Created'] = (created as any instanceof Date) ?
                    (created as any).toISOString() :
                    created;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all manager affiliations.
         * @param {string} managerId 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersManagerIdAffiliationsGet: async (managerId: string, hospitalId?: string, hospitalName?: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'managerId' is not null or undefined
            assertParamExists('apiV1ManagersManagerIdAffiliationsGet', 'managerId', managerId)
            const localVarPath = `/api/v1/managers/{managerId}/affiliations`
                .replace(`{${"managerId"}}`, encodeURIComponent(String(managerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (hospitalName !== undefined) {
                localVarQueryParameter['HospitalName'] = hospitalName;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete manager affiliation.
         * @param {string} managerId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersManagerIdAffiliationsHospitalIdDelete: async (managerId: string, hospitalId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'managerId' is not null or undefined
            assertParamExists('apiV1ManagersManagerIdAffiliationsHospitalIdDelete', 'managerId', managerId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1ManagersManagerIdAffiliationsHospitalIdDelete', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/managers/{managerId}/affiliations/{hospitalId}`
                .replace(`{${"managerId"}}`, encodeURIComponent(String(managerId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get manager affiliation.
         * @param {string} managerId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersManagerIdAffiliationsHospitalIdGet: async (managerId: string, hospitalId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'managerId' is not null or undefined
            assertParamExists('apiV1ManagersManagerIdAffiliationsHospitalIdGet', 'managerId', managerId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1ManagersManagerIdAffiliationsHospitalIdGet', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/managers/{managerId}/affiliations/{hospitalId}`
                .replace(`{${"managerId"}}`, encodeURIComponent(String(managerId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} managerId 
         * @param {CreateManagerAffiliationCommand} [createManagerAffiliationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersManagerIdAffiliationsPost: async (managerId: string, createManagerAffiliationCommand?: CreateManagerAffiliationCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'managerId' is not null or undefined
            assertParamExists('apiV1ManagersManagerIdAffiliationsPost', 'managerId', managerId)
            const localVarPath = `/api/v1/managers/{managerId}/affiliations`
                .replace(`{${"managerId"}}`, encodeURIComponent(String(managerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createManagerAffiliationCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Manager.
         * @param {string} managerId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersManagerIdDelete: async (managerId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'managerId' is not null or undefined
            assertParamExists('apiV1ManagersManagerIdDelete', 'managerId', managerId)
            const localVarPath = `/api/v1/managers/{managerId}`
                .replace(`{${"managerId"}}`, encodeURIComponent(String(managerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Manager.
         * @param {string} managerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersManagerIdGet: async (managerId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'managerId' is not null or undefined
            assertParamExists('apiV1ManagersManagerIdGet', 'managerId', managerId)
            const localVarPath = `/api/v1/managers/{managerId}`
                .replace(`{${"managerId"}}`, encodeURIComponent(String(managerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update Manager.
         * @param {string} managerId 
         * @param {UpdateManagerCommand} [updateManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersManagerIdPut: async (managerId: string, updateManagerCommand?: UpdateManagerCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'managerId' is not null or undefined
            assertParamExists('apiV1ManagersManagerIdPut', 'managerId', managerId)
            const localVarPath = `/api/v1/managers/{managerId}`
                .replace(`{${"managerId"}}`, encodeURIComponent(String(managerId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateManagerCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a Manager.
         * @param {CreateManagerCommand} [createManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersPost: async (createManagerCommand?: CreateManagerCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/managers`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createManagerCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ManagersApi - functional programming interface
 * @export
 */
export const ManagersApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ManagersApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all Managers.
         * @param {string} [hospitalId] 
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ManagersGet(hospitalId?: string, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ManagersModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ManagersGet(hospitalId, id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all manager affiliations.
         * @param {string} managerId 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ManagersManagerIdAffiliationsGet(managerId: string, hospitalId?: string, hospitalName?: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ManagerAffiliationsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ManagersManagerIdAffiliationsGet(managerId, hospitalId, hospitalName, languageCode, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete manager affiliation.
         * @param {string} managerId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ManagersManagerIdAffiliationsHospitalIdDelete(managerId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ManagersManagerIdAffiliationsHospitalIdDelete(managerId, hospitalId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get manager affiliation.
         * @param {string} managerId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ManagersManagerIdAffiliationsHospitalIdGet(managerId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ManagerAffiliationModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ManagersManagerIdAffiliationsHospitalIdGet(managerId, hospitalId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {string} managerId 
         * @param {CreateManagerAffiliationCommand} [createManagerAffiliationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ManagersManagerIdAffiliationsPost(managerId: string, createManagerAffiliationCommand?: CreateManagerAffiliationCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ManagerModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ManagersManagerIdAffiliationsPost(managerId, createManagerAffiliationCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Manager.
         * @param {string} managerId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ManagersManagerIdDelete(managerId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ManagersManagerIdDelete(managerId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Manager.
         * @param {string} managerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ManagersManagerIdGet(managerId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ManagerModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ManagersManagerIdGet(managerId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update Manager.
         * @param {string} managerId 
         * @param {UpdateManagerCommand} [updateManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ManagersManagerIdPut(managerId: string, updateManagerCommand?: UpdateManagerCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ManagerModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ManagersManagerIdPut(managerId, updateManagerCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a Manager.
         * @param {CreateManagerCommand} [createManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ManagersPost(createManagerCommand?: CreateManagerCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ManagerModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ManagersPost(createManagerCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * ManagersApi - factory interface
 * @export
 */
export const ManagersApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ManagersApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all Managers.
         * @param {string} [hospitalId] 
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersGet(hospitalId?: string, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<ManagersModel> {
            return localVarFp.apiV1ManagersGet(hospitalId, id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all manager affiliations.
         * @param {string} managerId 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersManagerIdAffiliationsGet(managerId: string, hospitalId?: string, hospitalName?: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<ManagerAffiliationsModel> {
            return localVarFp.apiV1ManagersManagerIdAffiliationsGet(managerId, hospitalId, hospitalName, languageCode, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete manager affiliation.
         * @param {string} managerId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersManagerIdAffiliationsHospitalIdDelete(managerId: string, hospitalId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ManagersManagerIdAffiliationsHospitalIdDelete(managerId, hospitalId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get manager affiliation.
         * @param {string} managerId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersManagerIdAffiliationsHospitalIdGet(managerId: string, hospitalId: string, options?: any): AxiosPromise<ManagerAffiliationModel> {
            return localVarFp.apiV1ManagersManagerIdAffiliationsHospitalIdGet(managerId, hospitalId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {string} managerId 
         * @param {CreateManagerAffiliationCommand} [createManagerAffiliationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersManagerIdAffiliationsPost(managerId: string, createManagerAffiliationCommand?: CreateManagerAffiliationCommand, options?: any): AxiosPromise<ManagerModel> {
            return localVarFp.apiV1ManagersManagerIdAffiliationsPost(managerId, createManagerAffiliationCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Manager.
         * @param {string} managerId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersManagerIdDelete(managerId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ManagersManagerIdDelete(managerId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Manager.
         * @param {string} managerId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersManagerIdGet(managerId: string, options?: any): AxiosPromise<ManagerModel> {
            return localVarFp.apiV1ManagersManagerIdGet(managerId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update Manager.
         * @param {string} managerId 
         * @param {UpdateManagerCommand} [updateManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersManagerIdPut(managerId: string, updateManagerCommand?: UpdateManagerCommand, options?: any): AxiosPromise<ManagerModel> {
            return localVarFp.apiV1ManagersManagerIdPut(managerId, updateManagerCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a Manager.
         * @param {CreateManagerCommand} [createManagerCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ManagersPost(createManagerCommand?: CreateManagerCommand, options?: any): AxiosPromise<ManagerModel> {
            return localVarFp.apiV1ManagersPost(createManagerCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1ManagersGet operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersGetRequest
 */
export interface ManagersApiApiV1ManagersGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly fullname?: string

    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly email?: string

    /**
     * 
     * @type {Gender}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly gender?: Gender

    /**
     * 
     * @type {Date}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly dateOfBirth?: Date

    /**
     * 
     * @type {Date}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly created?: Date

    /**
     * 
     * @type {boolean}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof ManagersApiApiV1ManagersGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1ManagersManagerIdAffiliationsGet operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersManagerIdAffiliationsGetRequest
 */
export interface ManagersApiApiV1ManagersManagerIdAffiliationsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsGet
     */
    readonly managerId: string

    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsGet
     */
    readonly hospitalName?: string

    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {number}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1ManagersManagerIdAffiliationsHospitalIdDelete operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdDeleteRequest
 */
export interface ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdDelete
     */
    readonly managerId: string

    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdDelete
     */
    readonly hospitalId: string
}

/**
 * Request parameters for apiV1ManagersManagerIdAffiliationsHospitalIdGet operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdGetRequest
 */
export interface ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdGet
     */
    readonly managerId: string

    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdGet
     */
    readonly hospitalId: string
}

/**
 * Request parameters for apiV1ManagersManagerIdAffiliationsPost operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersManagerIdAffiliationsPostRequest
 */
export interface ManagersApiApiV1ManagersManagerIdAffiliationsPostRequest {
    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsPost
     */
    readonly managerId: string

    /**
     * 
     * @type {CreateManagerAffiliationCommand}
     * @memberof ManagersApiApiV1ManagersManagerIdAffiliationsPost
     */
    readonly createManagerAffiliationCommand?: CreateManagerAffiliationCommand
}

/**
 * Request parameters for apiV1ManagersManagerIdDelete operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersManagerIdDeleteRequest
 */
export interface ManagersApiApiV1ManagersManagerIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdDelete
     */
    readonly managerId: string

    /**
     * 
     * @type {boolean}
     * @memberof ManagersApiApiV1ManagersManagerIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1ManagersManagerIdGet operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersManagerIdGetRequest
 */
export interface ManagersApiApiV1ManagersManagerIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdGet
     */
    readonly managerId: string
}

/**
 * Request parameters for apiV1ManagersManagerIdPut operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersManagerIdPutRequest
 */
export interface ManagersApiApiV1ManagersManagerIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof ManagersApiApiV1ManagersManagerIdPut
     */
    readonly managerId: string

    /**
     * 
     * @type {UpdateManagerCommand}
     * @memberof ManagersApiApiV1ManagersManagerIdPut
     */
    readonly updateManagerCommand?: UpdateManagerCommand
}

/**
 * Request parameters for apiV1ManagersPost operation in ManagersApi.
 * @export
 * @interface ManagersApiApiV1ManagersPostRequest
 */
export interface ManagersApiApiV1ManagersPostRequest {
    /**
     * 
     * @type {CreateManagerCommand}
     * @memberof ManagersApiApiV1ManagersPost
     */
    readonly createManagerCommand?: CreateManagerCommand
}

/**
 * ManagersApi - object-oriented interface
 * @export
 * @class ManagersApi
 * @extends {BaseAPI}
 */
export class ManagersApi extends BaseAPI {
    /**
     * 
     * @summary Get all Managers.
     * @param {ManagersApiApiV1ManagersGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    public apiV1ManagersGet(requestParameters: ManagersApiApiV1ManagersGetRequest = {}, options?: AxiosRequestConfig) {
        return ManagersApiFp(this.configuration).apiV1ManagersGet(requestParameters.hospitalId, requestParameters.id, requestParameters.fullname, requestParameters.email, requestParameters.gender, requestParameters.dateOfBirth, requestParameters.created, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all manager affiliations.
     * @param {ManagersApiApiV1ManagersManagerIdAffiliationsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    public apiV1ManagersManagerIdAffiliationsGet(requestParameters: ManagersApiApiV1ManagersManagerIdAffiliationsGetRequest, options?: AxiosRequestConfig) {
        return ManagersApiFp(this.configuration).apiV1ManagersManagerIdAffiliationsGet(requestParameters.managerId, requestParameters.hospitalId, requestParameters.hospitalName, requestParameters.languageCode, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete manager affiliation.
     * @param {ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    public apiV1ManagersManagerIdAffiliationsHospitalIdDelete(requestParameters: ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdDeleteRequest, options?: AxiosRequestConfig) {
        return ManagersApiFp(this.configuration).apiV1ManagersManagerIdAffiliationsHospitalIdDelete(requestParameters.managerId, requestParameters.hospitalId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get manager affiliation.
     * @param {ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    public apiV1ManagersManagerIdAffiliationsHospitalIdGet(requestParameters: ManagersApiApiV1ManagersManagerIdAffiliationsHospitalIdGetRequest, options?: AxiosRequestConfig) {
        return ManagersApiFp(this.configuration).apiV1ManagersManagerIdAffiliationsHospitalIdGet(requestParameters.managerId, requestParameters.hospitalId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {ManagersApiApiV1ManagersManagerIdAffiliationsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    public apiV1ManagersManagerIdAffiliationsPost(requestParameters: ManagersApiApiV1ManagersManagerIdAffiliationsPostRequest, options?: AxiosRequestConfig) {
        return ManagersApiFp(this.configuration).apiV1ManagersManagerIdAffiliationsPost(requestParameters.managerId, requestParameters.createManagerAffiliationCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Manager.
     * @param {ManagersApiApiV1ManagersManagerIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    public apiV1ManagersManagerIdDelete(requestParameters: ManagersApiApiV1ManagersManagerIdDeleteRequest, options?: AxiosRequestConfig) {
        return ManagersApiFp(this.configuration).apiV1ManagersManagerIdDelete(requestParameters.managerId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Manager.
     * @param {ManagersApiApiV1ManagersManagerIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    public apiV1ManagersManagerIdGet(requestParameters: ManagersApiApiV1ManagersManagerIdGetRequest, options?: AxiosRequestConfig) {
        return ManagersApiFp(this.configuration).apiV1ManagersManagerIdGet(requestParameters.managerId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update Manager.
     * @param {ManagersApiApiV1ManagersManagerIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    public apiV1ManagersManagerIdPut(requestParameters: ManagersApiApiV1ManagersManagerIdPutRequest, options?: AxiosRequestConfig) {
        return ManagersApiFp(this.configuration).apiV1ManagersManagerIdPut(requestParameters.managerId, requestParameters.updateManagerCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a Manager.
     * @param {ManagersApiApiV1ManagersPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ManagersApi
     */
    public apiV1ManagersPost(requestParameters: ManagersApiApiV1ManagersPostRequest = {}, options?: AxiosRequestConfig) {
        return ManagersApiFp(this.configuration).apiV1ManagersPost(requestParameters.createManagerCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
