/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateServiceCategoryCommand } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { ServiceCategoriesModel } from '../models';
// @ts-ignore
import { ServiceCategoryModel } from '../models';
// @ts-ignore
import { UpdateServiceCategoryCommand } from '../models';
/**
 * ServicesCategoriesApi - axios parameter creator
 * @export
 */
export const ServicesCategoriesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all ServiceCategories.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicescategoriesGet: async (id?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/servicescategories`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {CreateServiceCategoryCommand} [createServiceCategoryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicescategoriesPost: async (createServiceCategoryCommand?: CreateServiceCategoryCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/servicescategories`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createServiceCategoryCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete ServiceCategory.
         * @param {string} serviceCategoryId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicescategoriesServiceCategoryIdDelete: async (serviceCategoryId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'serviceCategoryId' is not null or undefined
            assertParamExists('apiV1ServicescategoriesServiceCategoryIdDelete', 'serviceCategoryId', serviceCategoryId)
            const localVarPath = `/api/v1/servicescategories/{serviceCategoryId}`
                .replace(`{${"serviceCategoryId"}}`, encodeURIComponent(String(serviceCategoryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get ServiceCategory.
         * @param {string} serviceCategoryId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicescategoriesServiceCategoryIdGet: async (serviceCategoryId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'serviceCategoryId' is not null or undefined
            assertParamExists('apiV1ServicescategoriesServiceCategoryIdGet', 'serviceCategoryId', serviceCategoryId)
            const localVarPath = `/api/v1/servicescategories/{serviceCategoryId}`
                .replace(`{${"serviceCategoryId"}}`, encodeURIComponent(String(serviceCategoryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update ServiceCategory
         * @param {string} serviceCategoryId 
         * @param {UpdateServiceCategoryCommand} [updateServiceCategoryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicescategoriesServiceCategoryIdPut: async (serviceCategoryId: string, updateServiceCategoryCommand?: UpdateServiceCategoryCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'serviceCategoryId' is not null or undefined
            assertParamExists('apiV1ServicescategoriesServiceCategoryIdPut', 'serviceCategoryId', serviceCategoryId)
            const localVarPath = `/api/v1/servicescategories/{serviceCategoryId}`
                .replace(`{${"serviceCategoryId"}}`, encodeURIComponent(String(serviceCategoryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateServiceCategoryCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ServicesCategoriesApi - functional programming interface
 * @export
 */
export const ServicesCategoriesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ServicesCategoriesApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all ServiceCategories.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicescategoriesGet(id?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceCategoriesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicescategoriesGet(id, name, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {CreateServiceCategoryCommand} [createServiceCategoryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicescategoriesPost(createServiceCategoryCommand?: CreateServiceCategoryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceCategoryModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicescategoriesPost(createServiceCategoryCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete ServiceCategory.
         * @param {string} serviceCategoryId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicescategoriesServiceCategoryIdDelete(serviceCategoryId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicescategoriesServiceCategoryIdDelete(serviceCategoryId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get ServiceCategory.
         * @param {string} serviceCategoryId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicescategoriesServiceCategoryIdGet(serviceCategoryId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceCategoryModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicescategoriesServiceCategoryIdGet(serviceCategoryId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update ServiceCategory
         * @param {string} serviceCategoryId 
         * @param {UpdateServiceCategoryCommand} [updateServiceCategoryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ServicescategoriesServiceCategoryIdPut(serviceCategoryId: string, updateServiceCategoryCommand?: UpdateServiceCategoryCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ServiceCategoryModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ServicescategoriesServiceCategoryIdPut(serviceCategoryId, updateServiceCategoryCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * ServicesCategoriesApi - factory interface
 * @export
 */
export const ServicesCategoriesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ServicesCategoriesApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all ServiceCategories.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicescategoriesGet(id?: string, name?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<ServiceCategoriesModel> {
            return localVarFp.apiV1ServicescategoriesGet(id, name, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {CreateServiceCategoryCommand} [createServiceCategoryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicescategoriesPost(createServiceCategoryCommand?: CreateServiceCategoryCommand, options?: any): AxiosPromise<ServiceCategoryModel> {
            return localVarFp.apiV1ServicescategoriesPost(createServiceCategoryCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete ServiceCategory.
         * @param {string} serviceCategoryId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicescategoriesServiceCategoryIdDelete(serviceCategoryId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ServicescategoriesServiceCategoryIdDelete(serviceCategoryId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get ServiceCategory.
         * @param {string} serviceCategoryId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicescategoriesServiceCategoryIdGet(serviceCategoryId: string, options?: any): AxiosPromise<ServiceCategoryModel> {
            return localVarFp.apiV1ServicescategoriesServiceCategoryIdGet(serviceCategoryId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update ServiceCategory
         * @param {string} serviceCategoryId 
         * @param {UpdateServiceCategoryCommand} [updateServiceCategoryCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ServicescategoriesServiceCategoryIdPut(serviceCategoryId: string, updateServiceCategoryCommand?: UpdateServiceCategoryCommand, options?: any): AxiosPromise<ServiceCategoryModel> {
            return localVarFp.apiV1ServicescategoriesServiceCategoryIdPut(serviceCategoryId, updateServiceCategoryCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1ServicescategoriesGet operation in ServicesCategoriesApi.
 * @export
 * @interface ServicesCategoriesApiApiV1ServicescategoriesGetRequest
 */
export interface ServicesCategoriesApiApiV1ServicescategoriesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesGet
     */
    readonly name?: string

    /**
     * 
     * @type {number}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1ServicescategoriesPost operation in ServicesCategoriesApi.
 * @export
 * @interface ServicesCategoriesApiApiV1ServicescategoriesPostRequest
 */
export interface ServicesCategoriesApiApiV1ServicescategoriesPostRequest {
    /**
     * 
     * @type {CreateServiceCategoryCommand}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesPost
     */
    readonly createServiceCategoryCommand?: CreateServiceCategoryCommand
}

/**
 * Request parameters for apiV1ServicescategoriesServiceCategoryIdDelete operation in ServicesCategoriesApi.
 * @export
 * @interface ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdDeleteRequest
 */
export interface ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdDelete
     */
    readonly serviceCategoryId: string
}

/**
 * Request parameters for apiV1ServicescategoriesServiceCategoryIdGet operation in ServicesCategoriesApi.
 * @export
 * @interface ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdGetRequest
 */
export interface ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdGet
     */
    readonly serviceCategoryId: string
}

/**
 * Request parameters for apiV1ServicescategoriesServiceCategoryIdPut operation in ServicesCategoriesApi.
 * @export
 * @interface ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdPutRequest
 */
export interface ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdPut
     */
    readonly serviceCategoryId: string

    /**
     * 
     * @type {UpdateServiceCategoryCommand}
     * @memberof ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdPut
     */
    readonly updateServiceCategoryCommand?: UpdateServiceCategoryCommand
}

/**
 * ServicesCategoriesApi - object-oriented interface
 * @export
 * @class ServicesCategoriesApi
 * @extends {BaseAPI}
 */
export class ServicesCategoriesApi extends BaseAPI {
    /**
     * 
     * @summary Get all ServiceCategories.
     * @param {ServicesCategoriesApiApiV1ServicescategoriesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesCategoriesApi
     */
    public apiV1ServicescategoriesGet(requestParameters: ServicesCategoriesApiApiV1ServicescategoriesGetRequest = {}, options?: AxiosRequestConfig) {
        return ServicesCategoriesApiFp(this.configuration).apiV1ServicescategoriesGet(requestParameters.id, requestParameters.name, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {ServicesCategoriesApiApiV1ServicescategoriesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesCategoriesApi
     */
    public apiV1ServicescategoriesPost(requestParameters: ServicesCategoriesApiApiV1ServicescategoriesPostRequest = {}, options?: AxiosRequestConfig) {
        return ServicesCategoriesApiFp(this.configuration).apiV1ServicescategoriesPost(requestParameters.createServiceCategoryCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete ServiceCategory.
     * @param {ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesCategoriesApi
     */
    public apiV1ServicescategoriesServiceCategoryIdDelete(requestParameters: ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdDeleteRequest, options?: AxiosRequestConfig) {
        return ServicesCategoriesApiFp(this.configuration).apiV1ServicescategoriesServiceCategoryIdDelete(requestParameters.serviceCategoryId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get ServiceCategory.
     * @param {ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesCategoriesApi
     */
    public apiV1ServicescategoriesServiceCategoryIdGet(requestParameters: ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdGetRequest, options?: AxiosRequestConfig) {
        return ServicesCategoriesApiFp(this.configuration).apiV1ServicescategoriesServiceCategoryIdGet(requestParameters.serviceCategoryId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update ServiceCategory
     * @param {ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ServicesCategoriesApi
     */
    public apiV1ServicescategoriesServiceCategoryIdPut(requestParameters: ServicesCategoriesApiApiV1ServicescategoriesServiceCategoryIdPutRequest, options?: AxiosRequestConfig) {
        return ServicesCategoriesApiFp(this.configuration).apiV1ServicescategoriesServiceCategoryIdPut(requestParameters.serviceCategoryId, requestParameters.updateServiceCategoryCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
