/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateTagCommand } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { StringFilterTypes } from '../models';
// @ts-ignore
import { TagModel } from '../models';
// @ts-ignore
import { TagsModel } from '../models';
/**
 * TagsApi - axios parameter creator
 * @export
 */
export const TagsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all Tags.
         * @param {string} [tagId] 
         * @param {StringFilterTypes} [filterType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1TagsGet: async (tagId?: string, filterType?: StringFilterTypes, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/tags`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (tagId !== undefined) {
                localVarQueryParameter['TagId'] = tagId;
            }

            if (filterType !== undefined) {
                localVarQueryParameter['FilterType'] = filterType;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a Tag.
         * @param {CreateTagCommand} [createTagCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1TagsPost: async (createTagCommand?: CreateTagCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/tags`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createTagCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Tag.
         * @param {string} tagId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1TagsTagIdDelete: async (tagId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'tagId' is not null or undefined
            assertParamExists('apiV1TagsTagIdDelete', 'tagId', tagId)
            const localVarPath = `/api/v1/tags/{tagId}`
                .replace(`{${"tagId"}}`, encodeURIComponent(String(tagId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Tag.
         * @param {string} tagId 
         * @param {boolean} [releatedTags] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1TagsTagIdGet: async (tagId: string, releatedTags?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'tagId' is not null or undefined
            assertParamExists('apiV1TagsTagIdGet', 'tagId', tagId)
            const localVarPath = `/api/v1/tags/{tagId}`
                .replace(`{${"tagId"}}`, encodeURIComponent(String(tagId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (releatedTags !== undefined) {
                localVarQueryParameter['releatedTags'] = releatedTags;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * TagsApi - functional programming interface
 * @export
 */
export const TagsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = TagsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all Tags.
         * @param {string} [tagId] 
         * @param {StringFilterTypes} [filterType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1TagsGet(tagId?: string, filterType?: StringFilterTypes, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TagsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1TagsGet(tagId, filterType, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a Tag.
         * @param {CreateTagCommand} [createTagCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1TagsPost(createTagCommand?: CreateTagCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TagModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1TagsPost(createTagCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Tag.
         * @param {string} tagId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1TagsTagIdDelete(tagId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1TagsTagIdDelete(tagId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Tag.
         * @param {string} tagId 
         * @param {boolean} [releatedTags] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1TagsTagIdGet(tagId: string, releatedTags?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TagModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1TagsTagIdGet(tagId, releatedTags, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * TagsApi - factory interface
 * @export
 */
export const TagsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = TagsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all Tags.
         * @param {string} [tagId] 
         * @param {StringFilterTypes} [filterType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1TagsGet(tagId?: string, filterType?: StringFilterTypes, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<TagsModel> {
            return localVarFp.apiV1TagsGet(tagId, filterType, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a Tag.
         * @param {CreateTagCommand} [createTagCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1TagsPost(createTagCommand?: CreateTagCommand, options?: any): AxiosPromise<TagModel> {
            return localVarFp.apiV1TagsPost(createTagCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Tag.
         * @param {string} tagId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1TagsTagIdDelete(tagId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1TagsTagIdDelete(tagId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Tag.
         * @param {string} tagId 
         * @param {boolean} [releatedTags] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1TagsTagIdGet(tagId: string, releatedTags?: boolean, options?: any): AxiosPromise<TagModel> {
            return localVarFp.apiV1TagsTagIdGet(tagId, releatedTags, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1TagsGet operation in TagsApi.
 * @export
 * @interface TagsApiApiV1TagsGetRequest
 */
export interface TagsApiApiV1TagsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof TagsApiApiV1TagsGet
     */
    readonly tagId?: string

    /**
     * 
     * @type {StringFilterTypes}
     * @memberof TagsApiApiV1TagsGet
     */
    readonly filterType?: StringFilterTypes

    /**
     * 
     * @type {number}
     * @memberof TagsApiApiV1TagsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof TagsApiApiV1TagsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof TagsApiApiV1TagsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1TagsPost operation in TagsApi.
 * @export
 * @interface TagsApiApiV1TagsPostRequest
 */
export interface TagsApiApiV1TagsPostRequest {
    /**
     * 
     * @type {CreateTagCommand}
     * @memberof TagsApiApiV1TagsPost
     */
    readonly createTagCommand?: CreateTagCommand
}

/**
 * Request parameters for apiV1TagsTagIdDelete operation in TagsApi.
 * @export
 * @interface TagsApiApiV1TagsTagIdDeleteRequest
 */
export interface TagsApiApiV1TagsTagIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof TagsApiApiV1TagsTagIdDelete
     */
    readonly tagId: string
}

/**
 * Request parameters for apiV1TagsTagIdGet operation in TagsApi.
 * @export
 * @interface TagsApiApiV1TagsTagIdGetRequest
 */
export interface TagsApiApiV1TagsTagIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof TagsApiApiV1TagsTagIdGet
     */
    readonly tagId: string

    /**
     * 
     * @type {boolean}
     * @memberof TagsApiApiV1TagsTagIdGet
     */
    readonly releatedTags?: boolean
}

/**
 * TagsApi - object-oriented interface
 * @export
 * @class TagsApi
 * @extends {BaseAPI}
 */
export class TagsApi extends BaseAPI {
    /**
     * 
     * @summary Get all Tags.
     * @param {TagsApiApiV1TagsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TagsApi
     */
    public apiV1TagsGet(requestParameters: TagsApiApiV1TagsGetRequest = {}, options?: AxiosRequestConfig) {
        return TagsApiFp(this.configuration).apiV1TagsGet(requestParameters.tagId, requestParameters.filterType, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a Tag.
     * @param {TagsApiApiV1TagsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TagsApi
     */
    public apiV1TagsPost(requestParameters: TagsApiApiV1TagsPostRequest = {}, options?: AxiosRequestConfig) {
        return TagsApiFp(this.configuration).apiV1TagsPost(requestParameters.createTagCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Tag.
     * @param {TagsApiApiV1TagsTagIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TagsApi
     */
    public apiV1TagsTagIdDelete(requestParameters: TagsApiApiV1TagsTagIdDeleteRequest, options?: AxiosRequestConfig) {
        return TagsApiFp(this.configuration).apiV1TagsTagIdDelete(requestParameters.tagId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Tag.
     * @param {TagsApiApiV1TagsTagIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TagsApi
     */
    public apiV1TagsTagIdGet(requestParameters: TagsApiApiV1TagsTagIdGetRequest, options?: AxiosRequestConfig) {
        return TagsApiFp(this.configuration).apiV1TagsTagIdGet(requestParameters.tagId, requestParameters.releatedTags, options).then((request) => request(this.axios, this.basePath));
    }
}
